var Ger97500_Tipo_De_Operacao_x_Cfop_Controller = function(ScreenService, templateManager, General, MessageService) {
    var self = this;

    var getMainWidget = function() {
        if (templateManager.container)
            return templateManager.container.widgets[0];
    };

    self.getFieldValue = function(field) {
        var mainWidget = getMainWidget();
        if (mainWidget) {
            var widgetAtiva = mainWidget.getParent().getActiveWidget();
            if (widgetAtiva.name == 'zhFilterPreferencesSelectConditions')
                return widgetAtiva.currentRow[field];
            else
                return mainWidget.appliedFilter.FILTER_ROW[field];
        }
    };

    self.justInteger = function(campos) {
        campos.forEach(function(campo) {
            General.justInteger(campo);
        });
    };
    
    this.deleteTipoOperCfop = function (parentWidget){
        MessageService.confirmMessageByCode('REGISTRO_EXCLUIR').then(sucess => {
            parentWidget.removeRow().then(function () {
                ScreenService.closeSwipe();
                MessageService.successNotificationByCode('REGISTRO_EXCLUIDO');
                parentWidget.reload();
                parentWidget.activate();
            }, function (error) {
                if (error.data && error.data.error.indexOf('ORA-02292') !== -1) {
                    MessageService.showMessageByCode('ERRO_EXCLUSAO_NAO_PERMITIDA');
                } else {
                    ScreenService.showMessage(error.data.error);
                }
            });
            
        });
    };
    
    this.controlaStatusWidgets = function(widgetPai, widgetAtual, status, ignoredWidgets) {
        var allWidgets = widgetPai.widgets;

        allWidgets.filter(widget => widget.name !== widgetAtual.name).forEach(widget => widget.enabled = status);

        if (widgetPai.name != widgetAtual.name)
            widgetPai.enabled = status;

        if (Array.isArray(ignoredWidgets))
            allWidgets.filter(widget => ignoredWidgets.indexOf(widget.name) !== -1).forEach(widget => widget.enabled = !status);
    };
    
    this.esOnChange = function (args){
        let wid = args.owner.owner.widget;
        let codTipoOp = wid.getField("CDTIPOOPER");
        codTipoOp.setValue(null);
        codTipoOp.reload();
    };
    
    this.corrigeFiltro = function (args) {
        let filtroES = args.owner.widget.appliedFilter.FILTER_ROW.IDENTRSAIDOP;
        args.owner.widget.currentRow.IDENTRSAIDOP = filtroES;
    };
    
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Ger97500_Tipo_De_Operacao_x_Cfop_Controller", Ger97500_Tipo_De_Operacao_x_Cfop_Controller);
});
