var dfs11000_LancamentoSaida_Controller = function(ScreenService, MessageService, templateManager, Df11000_Lancamento_Service, Dfs11000_LancamentoSaida_Service, General, ValidacoesEstoque_Service, ZhFilterPreferences, ErrosReplicacaoDocumentos_Utilities, Lib00206_InfComplProduto_Controller, localStorageEngine, ZHPromise) {
    
    var CDFILIEMIT;
    
    var getCabecalhoWidget = function(){
        if(templateManager.container)
            return templateManager.container.getWidget("cabecalho");
    };

    var getItensWidget = function(){
        return templateManager.container.getWidget("itens");
    };
    
    var requestError = function(error){
        var errorMessage = "Ocorreu um erro ao tentar realizar a operação.";
        if (error && error.data) {
            errorMessage = error.data.error;
        }
        ScreenService.showMessage(errorMessage, "ERROR");
    };
    
    //Função que ajusta casas decimais de valor unitario de acordo com o parametro
    //Desativada por enquanto até futura definição
    this.ajustaCasasDecimais = function(){
        var itemsWidget = getItensWidget();
        var fieldItem = itemsWidget.getField('VRUNITITEM');
        
        /*General.callRestEngine('df#/crud/paramgeral', 'FilterData', []).then(function(success) {
            if(success.dataset.paramgeral[0]){
                var paramgeral = success.dataset.paramgeral[0];
                fieldItem.mask.params.precision = paramgeral.NRDECITOTANF;
            }
        });*/
    };
    
    this.actNovaNota = function(args) {
        Df11000_Lancamento_Service.removeDataSourceLancamentoNota();
        Df11000_Lancamento_Service.inicializaLancamento();
        Df11000_Lancamento_Service.setDataSourceLancamentoNota().then(function(){
            validaCampoModDocFiscal(args.owner.widget, []);
            //validaCampoEmpresa(args);
            validaCampoSerie(args.row, true);
            args.owner.widget.newRow();
            controlaStatusWidgets(args.owner.widget, args.owner.widget.name, false);
            buscaItensNotaOrigem = true;
            setCamposDefaultValueCabecalho(args)
            .then(() => {
                    var widgetCabecalho = templateManager.container.getWidget('cabecalho');
                    widgetCabecalho.redraw();
                    //widgetCabecalho.reload();
                });
        });
    };

    var reloadWidgetsFilhas = function(widgetPai) {
        widgetPai.widgets.forEach(function(widgetFilha) {
            widgetFilha.reload();
        });
    };

    this.encargoOnChange = function(args){
        var field = args.owner.field;
        
        if (!field.value()){
            field.setValue(0);
        }
        controlaStatusWidgets(args.owner.field.widget.getParent(), args.owner.field.widget.name, false);
    };

    this.unidadeDestinatarioOnChange = function(widget) {
        var currentRow = widget.currentRow;
        
        if (currentRow.CDFILIRECE == currentRow.CDFILIEMIT) {
            ScreenService.showMessage("Unidade de origem deve ser diferente da unidade de destino.");
            currentRow.DSFILIRECE = null;
            currentRow.CDFILIRECE = null;
            currentRow.CDEMPRESARECE = null;
        }
        else if (currentRow.CDEMPRESARECE != currentRow.CDEMPRESA) {
            ScreenService.showMessage("Unidade de destino deve possuir a mesma empresa da nota fiscal.");
            currentRow.DSFILIRECE = null;
            currentRow.CDFILIRECE = null;
            currentRow.CDEMPRESARECE = null;
        }
        widget.reload();
    };

    this.destinatarioOnChange = function(field) {
        var currentRow = field.widget.currentRow;
        
        currentRow.DSINSJURNF = currentRow[field.name];
    };

    this.qtdiasvenrecOnChange = function(field) {
        var currentRow = field.widget.currentRow;
        
        if (currentRow.QTDIASVENREC) {
            var parentCurrentRow = field.widget.getParent().currentRow;
            currentRow.DTATUAVENREC = moment(parentCurrentRow.DTENTRSAID, "DD/MM/YYYY").add(currentRow.QTDIASVENREC, "days").format("DD/MM/YYYY");
        }
    };

    this.dtatuavenrecOnChange = function(field) {
        var currentRow = field.widget.currentRow;
        
        if (currentRow.DTATUAVENREC) {
            var parentCurrentRow = field.widget.getParent().currentRow;
            var dataNota = moment(parentCurrentRow.DTENTRSAID, "DD/MM/YYYY");
            var dataInserida = moment(currentRow.DTATUAVENREC, "DD/MM/YYYY");
            currentRow.QTDIASVENREC = dataInserida.diff(dataNota, "days").toString();
        }
    };

    var controlaStatusWidgets = function(widgetPai, nomeWidgetAtual, status){
        widgetPai.widgets.forEach(function(widg){
            if(nomeWidgetAtual !== widg.name)
                widg.enabled = status;
        });

        if(widgetPai.name !== nomeWidgetAtual)
            widgetPai.enabled = status;
    };

    this.criaDetalhesLancamentoWidgetAfterMoveRow = function(consultaLancamentoArgs) {
        buscaItensNotaOrigem = true;
        return Df11000_Lancamento_Service.criaDetalhesLancamento(consultaLancamentoArgs.row).then(function(lancamentoSaida) {
            templateManager.container.getWidget("itens").dataSource.data = lancamentoSaida.ITENS;
            templateManager.container.getWidget("impostos").dataSource.data = lancamentoSaida.IMPOSTO;
            templateManager.container.getWidget("encargos").dataSource.data = lancamentoSaida.ENCARGO;
            templateManager.container.getWidget("vencimentos").dataSource.data = lancamentoSaida.VENCIMENTO;
            templateManager.container.getWidget("dados_adicionais").dataSource.data = lancamentoSaida.DADOSADICIONAIS;
            return true;
        });
    };

    this.removeDataSourcesConsultaLancSaidaActionEvent = function() {
        Df11000_Lancamento_Service.removeDataSourceLancamentoNota();
    };
    
    /* var alteraVisibilidadeRemetenteDestinatario = function(){
    //     var cabecalhoWidget = getCabecalhoWidget();
    //     var allFields = cabecalhoWidget.fields;
    //     var remetenteDestinatario = allFields.filter(function(field){
    //         return field.fieldGroup === "destinatario" || field.fieldGroup === "remetente";
    //     });
    //     remetenteDestinatario.forEach(function(field){
    //         field.showOnView = cabecalhoWidget.currentRow.IDSTATUS !== "D";
    //     });
    // };*/

    var validaEdicaoNota = function() {
        var cabecalhoWidget = getCabecalhoWidget();
        var statusNota = cabecalhoWidget.currentRow.IDSTATUS || 'D';
        var statusNotaTransmissao = cabecalhoWidget.currentRow.IDSTATUSNFE;
        var notaCanceladaOuAprvada = (statusNota === 'A' || statusNota === 'C');
        var notaTransmissao = (statusNotaTransmissao === 'T' || statusNotaTransmissao === 'A' || statusNotaTransmissao === 'C' || statusNotaTransmissao === 'D');
        var permiteEditarNota = (!notaCanceladaOuAprvada && !notaTransmissao && (statusNota === 'D' || statusNota === 'P'));
        var allActions = cabecalhoWidget.getActions();

        var invisibleActions   = allActions.filter(function(action) {
            var widgetName     = action.widget.name;
            var actionName     = action.name.toLowerCase();
            var isActionVoltar = (actionName.indexOf('voltar') === -1);
            var novaNota       = (actionName.indexOf('novo') !== -1 && widgetName === 'cabecalho');
            var zeedhiWidgets  = (widgetName !== 'filterPopup' && widgetName !== 'stripe');
            return (isActionVoltar && zeedhiWidgets && !novaNota);
        });
        invisibleActions.forEach(function(action) {
            if(action.name !== 'REPLICARDOCUMENTO' && action.name !== 'INVISIBLEACTION' && action.name != "COPIARNOTA") action.isVisible = permiteEditarNota;
            else action.isVisible = (statusNota !== 'D');
            var encargoInlineEdit = cabecalhoWidget.container.getWidget('encargos').getField('VRITEMENCA');
            if(!!permiteEditarNota)
                encargoInlineEdit.inlineEditable = "number";
            else
                delete encargoInlineEdit.inlineEditable;

            if (action.name.toLowerCase().indexOf('fecharnota') !== -1 && statusNota === 'P')
                action.isVisible = false;
        });
    };

    var validaEdicaoItensServico = function(cabecalhoWidget){
        if(cabecalhoWidget.currentRow.IDORIGDESTNF === "C"){
            var itensWidget = cabecalhoWidget.container.getWidget("itens");
            var item = itensWidget.dataSource.data[0];
            if(cabecalhoWidget.appliedFilter.FILTER_ROW.IDBLOQITNFAPUR === "S" &&
                itensWidget.dataSource.data.length !== 0 &&
                (item.CDSERVFILI || item.CDSERVFATU)){

                itensWidget.getAction("novoItem").isVisible = false;
                itensWidget.getAction("novoServico").isVisible = false;
            }
            else{
                itensWidget.getAction("novoItem").isVisible = true;
                itensWidget.getAction("novoServico").isVisible = true;
            }
        }
    };

    var alteraVisibilidadeBotaoIncluirServico = function(widget){
        if(widget.currentRow.IDORIGDESTNF === "C"){
            Dfs11000_LancamentoSaida_Service.retornaClienteFilial(
                widget.currentRow.CDFILIEMIT,
                widget.currentRow.CDCLIENTE).then(function(clienteFilial){
                    if(clienteFilial.length !== 0)
                        widget.container.getWidget("itens").getAction("novoServico").isVisible = true;
                    else
                        widget.container.getWidget("itens").getAction("novoServico").isVisible = false;
                });
        }
        else{
            widget.container.getWidget("itens").getAction("novoServico").isVisible = false;
        }
    };

    var validaNotaServico = function(cabecalhoWidget){
        validaEdicaoItensServico(cabecalhoWidget);
        alteraVisibilidadeBotaoIncluirServico(cabecalhoWidget);
    };

    this.validacoesNotaAfterMoveRow = function(args) {
        let widget = args.owner;
        
        Df11000_Lancamento_Service.removeDataSourceLancamentoNota();
        if(args.row.__is_new === false) {
            this.criaDetalhesLancamentoWidgetAfterMoveRow(args).then(function(){
                validaNotaServico(args.owner);
            });
        }
        validaEdicaoNota();
        //this.setCamposDefaultValueWidgetOnEnter(args);
        // alteraVisibilidadeRemetenteDestinatario();
        alteraVisibilidadeCampoInscricao();
        // validaCamposDocumentoOrigem(getCabecalhoWidget(), args.row);
        preparaCamposDocumentoOrigem(args);
        
        widget.getField('NMTIPOOPER').reload().then(() => {
            let widget = templateManager.container.getActiveWidget();
            if(!widget.editing) { //True = Visualizar nota.
                this.controlVisibilityLocalPrestServ(widget);
            }
        });
    };

    this.excluirNotaActionEvent = function(consultaLancamentoArgs) {
        ScreenService.confirmMessage('Deseja excluir a nota fiscal?', 'question', function (success) {
            var filter = [
                {
                    "name": "IDDOCREPLIC",
                    "operator": "=",
                    "value": consultaLancamentoArgs.row.CDFILIAL.concat(consultaLancamentoArgs.row.NRLANCTONF)
                }    
            ];
            General.callRestEngine('df_saida#/crud/notaReplicada_tipooperac', 'FilterData', filter).then(function(success) {
                if(success.dataset.notaReplicada_tipooperac[0]) this.openReplicacaoExclusao(consultaLancamentoArgs);
                else this.excluirNota(consultaLancamentoArgs);
            }.bind(this));
        }.bind(this));
    };
    
    this.excluirNota = function(consultaLancamentoArgs) {
        Dfs11000_LancamentoSaida_Service.excluirNota(consultaLancamentoArgs.row).then(function() {
            General.backOrCancel(consultaLancamentoArgs);
            var rowExcluida = consultaLancamentoArgs.owner.widget.dataSource.data.filter(function(notafiscal){
                return consultaLancamentoArgs.row.NRLANCTONF === notafiscal.NRLANCTONF;
            });
            var index = consultaLancamentoArgs.owner.widget.dataSource.data.indexOf(rowExcluida[0]);
            consultaLancamentoArgs.owner.widget.dataSource.data.splice(index, 1);
            //consultaLancamentoArgs.owner.widget.reload();
            ScreenService.showMessage('Nota Fiscal excluída com sucesso');
        }, function (error) {
            requestError(error);
        });
    };
    
    var alteraStatusNotafiscal = function(widget){
        if(widget.getParent().currentRow.IDSTATUS !== 'D'){
            widget.getParent().currentRow.IDSTATUS = 'D';
            Df11000_Lancamento_Service.salvaCabecalho(widget.getParent().currentRow).then(function(){}, requestError);
            // alteraVisibilidadeRemetenteDestinatario();
            validaEdicaoNota();
        }
    };
    
   var confereFilialLogada = function(lancamentoCabecalhoArgs){
        var deferred = ZHPromise.defer();
        if(!lancamentoCabecalhoArgs.row.hasOwnProperty('CDFILIAL')){
          Dfs11000_LancamentoSaida_Service.getFilial().then(function(result){
              lancamentoCabecalhoArgs.row.CDFILIAL = result.dataset.filial[0].CDFILIAL;
              deferred.resolve();
          });
        }
        else{
            deferred.resolve();
        }
        return deferred;
    };

    this.salvaLancamentoCabecalho = function(lancamentoCabecalhoArgs) {
        
     confereFilialLogada(lancamentoCabecalhoArgs).then(function(success){

        if (lancamentoCabecalhoArgs.owner.widget.isValid()) {
            if (!lancamentoCabecalhoArgs.row.CDCLIENTE && !lancamentoCabecalhoArgs.row.CDFILIRECE && !lancamentoCabecalhoArgs.row.CDFORNECED)
                return ScreenService.showMessage("Destinatário da Nota Fiscal não informado.");

            if (lancamentoCabecalhoArgs.row.CDFILIRECE) {
                if (lancamentoCabecalhoArgs.row.CDFILIRECE == lancamentoCabecalhoArgs.row.CDFILIEMIT) {
                    lancamentoCabecalhoArgs.row.DSFILIRECE = null;
                    lancamentoCabecalhoArgs.row.CDFILIRECE = null;
                    lancamentoCabecalhoArgs.row.CDEMPRESARECE = null;
                    return ScreenService.showMessage("Unidade de origem deve ser diferente da unidade de destino.");
                }
                else if (lancamentoCabecalhoArgs.row.CDEMPRESARECE != lancamentoCabecalhoArgs.row.CDEMPRESA) {
                    lancamentoCabecalhoArgs.row.DSFILIRECE = null;
                    lancamentoCabecalhoArgs.row.CDFILIRECE = null;
                    lancamentoCabecalhoArgs.row.CDEMPRESARECE = null;
                    return ScreenService.showMessage("Unidade de destino deve possuir a mesma empresa da nota fiscal.");
                }
            }

            ValidacoesEstoque_Service.validaDataLancamento(lancamentoCabecalhoArgs.row.CDFILIEMIT, lancamentoCabecalhoArgs.row.DTENTRSAID, "SAIDA", "DFS").then(function(){
                if(lancamentoCabecalhoArgs.row.__is_new){
                    //lancamentoCabecalhoArgs.row.__new_code_pk = lancamentoCabecalhoArgs.owner.widget.paramsNewCode.__new_code_pk+lancamentoCabecalhoArgs.row.CDFILIAL;
                    lancamentoCabecalhoArgs.row.__new_code_pk = lancamentoCabecalhoArgs.owner.widget.paramsNewCode.__new_code_pk;
                    lancamentoCabecalhoArgs.row.__using_unit = lancamentoCabecalhoArgs.owner.widget.paramsNewCode.__using_unit;
                    lancamentoCabecalhoArgs.row.__table_pk = lancamentoCabecalhoArgs.owner.widget.paramsNewCode.__table_pk;
                    lancamentoCabecalhoArgs.row.__new_code_length = lancamentoCabecalhoArgs.owner.widget.paramsNewCode.__new_code_length || 5;
                    lancamentoCabecalhoArgs.row.__columns_to_return = lancamentoCabecalhoArgs.owner.widget.paramsNewCode.__columns_to_return;
                    lancamentoCabecalhoArgs.row.VRPRODUTOS = 0;
                    lancamentoCabecalhoArgs.row.VRNOTAFISC = 0;
                    lancamentoCabecalhoArgs.row.IDENTRSAIDOP = "S";
                    lancamentoCabecalhoArgs.row.IDBLOQUEADO = "N";
                    lancamentoCabecalhoArgs.row.IDSISTEMA = "DFS";
                    lancamentoCabecalhoArgs.row.IDDOCFINANC = "S";
                }

                lancamentoCabecalhoArgs.row.IDSTATUS     = "D";
                lancamentoCabecalhoArgs.row.CDINSCESTA   = lancamentoCabecalhoArgs.row.IEREM;
                lancamentoCabecalhoArgs.row.NRSEQCAPADOC = "";
                lancamentoCabecalhoArgs.row.DTCOMPFATUR  = moment().format("DD/MM/YYYY LTS");
                
                Df11000_Lancamento_Service.salvaCabecalho(lancamentoCabecalhoArgs.row).then(function(callback){
                    var rowDADOSERVPRESnew = false;
                    
                    if(lancamentoCabecalhoArgs.row.__is_new){
                        if(lancamentoCabecalhoArgs.row.IDUTILNFSE === 'S') rowDADOSERVPRESnew = true;
                        lancamentoCabecalhoArgs.row.CDFILIAL = callback.dataset.columnsToReturn[0].CDFILIAL;
                        lancamentoCabecalhoArgs.row.NRLANCTONF = callback.dataset.columnsToReturn[0].NRLANCTONF;
                        lancamentoCabecalhoArgs.row.NRORG = callback.dataset.columnsToReturn[0].NRORG;

                        //OPERAÇÕES DE DEVOLUÇÃO
                        if(lancamentoCabecalhoArgs.row.IDOPERDEVONF === 'S' && lancamentoCabecalhoArgs.row.__is_new === true){
                            lancamentoCabecalhoArgs.row.CDFILIALIT = lancamentoCabecalhoArgs.row.CDFILINOTAORIG;
                            lancamentoCabecalhoArgs.row.NRLANCTONFIT = lancamentoCabecalhoArgs.row.NRLANCNOTAORIG;
                            lancamentoCabecalhoArgs.row.NRSEQUITNOTA = "001";

                            var itemnotafisc = {
                                "CDFILIAL": lancamentoCabecalhoArgs.row.CDFILIAL,
                                "NRLANCTONF": lancamentoCabecalhoArgs.row.NRLANCTONF,
                                "CDFILIALIT": lancamentoCabecalhoArgs.row.CDFILINOTAORIG,
                                "NRLANCTONFIT": lancamentoCabecalhoArgs.row.NRLANCNOTAORIG,
                                "NRSEQUITNOTA": "001",
                                "__is_new": true
                            };
                            Df11000_Lancamento_Service.salvaItemnotafisc(itemnotafisc).then(function(){}, requestError);
                        }
                        //@todo remover __is_new quando widget.edit() funcionar
                        lancamentoCabecalhoArgs.row.__is_new = false;
                        reloadWidgetsFilhas(lancamentoCabecalhoArgs.owner.widget);
                    }
                    Df11000_Lancamento_Service.setDataSourceCabecalho(lancamentoCabecalhoArgs.row);
                    Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                    lancamentoCabecalhoArgs.owner.widget.view();
                    validaEdicaoNota();
                    habilitaCamposItemNotaOrigem(getItensWidget(), lancamentoCabecalhoArgs.row);
                    alteraVisibilidadeBotaoIncluirServico(lancamentoCabecalhoArgs.owner.widget);
                    // alteraVisibilidadeRemetenteDestinatario();
                    controlaStatusWidgets(lancamentoCabecalhoArgs.owner.widget, lancamentoCabecalhoArgs.owner.widget.name, true);
                    
                    if(lancamentoCabecalhoArgs.row.IDUTILNFSE === 'S') {
                        let rowDADOSERVPRES = setRowDADOSERVPRES(lancamentoCabecalhoArgs.row);
                        
                        if(rowDADOSERVPRESnew) {
                            rowDADOSERVPRES.__is_new         = true;
                            General.callRestEngine('df#/crud/dadoservpres/save', "Row", rowDADOSERVPRES);
                        }
                        else {
                            let filter = [{"name":"CDFILIAL"  , "operator":"=", "value": rowDADOSERVPRES.CDFILIAL},
                                          {"name":"NRLANCTONF", "operator":"=", "value": rowDADOSERVPRES.NRLANCTONF}];
                                          
                            General.callRestEngine('df#/crud/dadoservpres', 'FilterData', filter)
                                .then((sucess) => {
                                    rowDADOSERVPRES.__is_new = sucess.dataset.dadoservpres.length ? false : true;
                                    General.callRestEngine('df#/crud/dadoservpres/save', "Row", rowDADOSERVPRES);
                                });
                        }
                    }
                }, requestError);
            }, requestError);
        }
     });
    };
    
    var setRowDADOSERVPRES = function(lancamentoCabecalhoArgsRow){
        let rowDADOSERVPRES = {};
        rowDADOSERVPRES.CDFILIAL             = lancamentoCabecalhoArgsRow.CDFILIAL;
        rowDADOSERVPRES.NRLANCTONF           = lancamentoCabecalhoArgsRow.NRLANCTONF;
        rowDADOSERVPRES.IDNATUOPER           = lancamentoCabecalhoArgsRow.IDNATUOPER;
        rowDADOSERVPRES.CDPAISPRESSERV       = lancamentoCabecalhoArgsRow.CDPAISNOTA;
        rowDADOSERVPRES.SGESTADOPRESSERV     = lancamentoCabecalhoArgsRow.SGESTADONOTA;
        rowDADOSERVPRES.CDMUNICIPRESSERV     = lancamentoCabecalhoArgsRow.CDMUNICIPIONOTA;
        rowDADOSERVPRES.NRORG                = lancamentoCabecalhoArgsRow.NRORG;
        rowDADOSERVPRES.IDATIVO              = 'S';
        return rowDADOSERVPRES;
    };

    this.actEditarCabecalhoOnClick = function(detalhesCabecalhoArgs) {
        General.edit(detalhesCabecalhoArgs.owner.widget);
        controlaStatusWidgets(detalhesCabecalhoArgs.owner.widget, detalhesCabecalhoArgs.owner.widget.name, false);
        validaCampoModDocFiscal(detalhesCabecalhoArgs.owner.widget, detalhesCabecalhoArgs.row);
        this.controlVisibilityLocalPrestServ(detalhesCabecalhoArgs.owner.widget);
        
    };

    this.getCurrentField = function(field) {
        var cabecalhoWidget = getCabecalhoWidget();
        if (cabecalhoWidget)
             return !cabecalhoWidget.currentRow[field] ? null : cabecalhoWidget.currentRow[field];
        return null;
    };

    this.getSequencialItemSelecionado = function(args){
        return '0001';
    };

    var validaCampoModDocFiscal = function(lancamentoCabecalhoWidget, lancamentoCabecalhoRow) {
         var descModFisc = lancamentoCabecalhoWidget.getField("DSMODDOCFISC");
         descModFisc.readOnly = !lancamentoCabecalhoRow.CDTIPOOPER;

         var tipoOperac = lancamentoCabecalhoRow.CDTIPOOPER;
         if (tipoOperac === "09" || tipoOperac === "10")
             delete descModFisc.validations;
         else
             descModFisc.validations = {"required": true};
    };

    var validaCampoEmpresa = function(lancamentoCabecalhoArgs) {
        var empresa = getCabecalhoWidget().getField("NMEMPRESA");
        empresa.readOnly = !lancamentoCabecalhoArgs.row.CDFILIEMIT;
    };

    var validaCampoSerie = function(lancamentoCabecalhoRow, limpaCampo) {
        var serie = getCabecalhoWidget().getField("DSSERIE");
        serie.readOnly = !lancamentoCabecalhoRow.NMEMPRESA;

        if (!!limpaCampo)
            serie.value(null);

        var tipoOperac = lancamentoCabecalhoRow.CDTIPOOPER;
        if (lancamentoCabecalhoRow.IDSERIEAUTO === 'S' && (tipoOperac === "09" || tipoOperac === "10"))
            delete serie.validations;
        else
            serie.validations = {"required": true};
    };

    var limpaCamposOutDataSelectsTpOperac = function(widget)    {
         widget =  !widget ? getCabecalhoWidget() : widget; 
        var cabecalhoWidget = getCabecalhoWidget();
        var cabecalhoRow = widget.currentRow;
        var cliente = widget.getField("NMRAZSOCCLIE");
        var fornecedor = widget.getField("NMRAZSOCFORN");
        var filial = widget.getField("DSFILIRECE");

        filial.value(null); 
         
        cliente.value(null);
        cabecalhoRow.CDCLIENTE = null;

        fornecedor.value(null);
        cabecalhoRow.CDFORNECED = null;
        cabecalhoRow.IDSITUCADA = null;
        cabecalhoRow.IDBLQNFRELAFOAF = null;

        cabecalhoRow.NRINSJURNF = null;
        cabecalhoRow.NMINSJURNF = null;
        cabecalhoRow.IDTPIJURNF = null;
    };

    var setCampoObrigatorio = function(field, readOnly) {
         field.isVisible = true;
         field.validations = {"required": true};
         field.readOnly = !!readOnly;
    };

    var setCampoNaoObrigatorio = function(field) {
         field.isVisible = false;
         delete field.validations;
         field.readOnly = true;
    };

    var validacaoCamposOutTpOperac = function(princialField) {
        setCampoObrigatorio(princialField);
        princialField.showOnView = true;
        princialField.showOnForm = true;
        princialField.isVisible = true;

        for (var i = 1; i < arguments.length; i++) {
            setCampoNaoObrigatorio(arguments[i]);
            arguments[i].showOnView = false;
            arguments[i].showOnForm = false;
            arguments[i].isVisible = false;
        }
    };

    var preparaCamposDocumentoOrigem = function(args){
        habilitaCamposCabecalhoNotaOrigem(args.owner, args.row);
        habilitaCamposItemNotaOrigem(getItensWidget(), args.row);
    };

    var validaCamposDocumentoOrigem = function(lancamentoCabecalhoWidget, lancamentoCabecalhoRow) {
        var serieOrigem = lancamentoCabecalhoWidget.getField("CDSERIEORIGEM");
        var notaOrigem = lancamentoCabecalhoWidget.getField("DSNOTAORIGEM");

        serieOrigem.value(null);
        notaOrigem.value(null);

        lancamentoCabecalhoRow.CDFILINOTAORIG = null;
        lancamentoCabecalhoRow.NRNOTAFISCORIGEM = null;
        lancamentoCabecalhoRow.NRLANCNOTAORIG = null;

        habilitaCamposItemNotaOrigem(getItensWidget(), lancamentoCabecalhoRow);

        if (lancamentoCabecalhoRow.IDORIGDESTOP == "F" && lancamentoCabecalhoRow.IDOPERDEVONF == "S") {
            setCampoObrigatorio(serieOrigem, true);
            setCampoObrigatorio(notaOrigem, !lancamentoCabecalhoWidget.getField("NMRAZSOCFORN").value());
            return true;
        }
        
        setCampoNaoObrigatorio(serieOrigem);
        setCampoNaoObrigatorio(notaOrigem);
        return false;
    };

    this.idorigdestOnChange = function(filterArgs) {
        alteraVisibilidadeCampoInscricaoFiltro(filterArgs);
        limpaCamposOutDataSelectsTpOperacFiltro(filterArgs);
    };

    var alteraVisibilidadeCampoInscricaoFiltro = function(filterArgs) {
        var filtroWidget = filterArgs.owner.field.widget;
        var cliente = filtroWidget.getField("NMRAZSOCCLIE");
        var fornecedor = filtroWidget.getField("NMRAZSOCFORN");
        var filial = filtroWidget.getField("DSFILIRECE");
        var tipoDestino = filterArgs.row.IDORIGDESTNF;

        switch (tipoDestino) {
            case "C":
                validacaoCamposOutTpOperacFilter(cliente, fornecedor, filial);
                break;
            case "F":
                validacaoCamposOutTpOperacFilter(fornecedor, cliente, filial);
                break;
            case "L":
                validacaoCamposOutTpOperacFilter(filial, fornecedor, cliente);
                break;
            default:
                filial.readOnly = true;
                cliente.readOnly = true;
                fornecedor.readOnly = true;
                filtroWidget.currentRow.DSFILIRECE = null;
                filtroWidget.currentRow.NMRAZSOCCLIE = null;
                filtroWidget.currentRow.NMRAZSOCFORN = null;
        }
    };

    var validacaoCamposOutTpOperacFilter = function(princialField) {
        princialField.showOnView = true;
        princialField.showOnForm = true;
        princialField.isVisible = true;
        princialField.readOnly = false;

        for (var i = 1; i < arguments.length; i++) {
            arguments[i].showOnView = false;
            arguments[i].showOnForm = false;
            arguments[i].isVisible = false;
            arguments[i].readOnly = true;
        }
    };

    this.tipoOperacaoOnChange = function(cabecalhoArgs) {
        var hasFieldValueFilial = !!cabecalhoArgs.owner.field.value();
        var cabecalhoCurrentRow = cabecalhoArgs.row;
        var cabecalhoWidget = cabecalhoArgs.owner.field.widget;

        cabecalhoCurrentRow.IDORIGDESTNF = cabecalhoCurrentRow.IDORIGDESTOP;

        alteraVisibilidadeCampoInscricao();

        validaCampoModDocFiscal(cabecalhoWidget, cabecalhoCurrentRow);
        validaCamposDocumentoOrigem(cabecalhoWidget, cabecalhoCurrentRow);
        validaCampoSerie(cabecalhoCurrentRow);
        limpaCamposOutDataSelectsTpOperac();
        this.controlVisibilityLocalPrestServ(cabecalhoWidget);
    };

    var limpaCamposOutDataSelectsTpOperacFiltro = function(filterArgs)    {
        var filtroWidget = filterArgs.owner.field.widget;
        var cabecalhoRow = filtroWidget.currentRow;
        var cliente = filtroWidget.getField("NMRAZSOCCLIE");
        var fornecedor = filtroWidget.getField("NMRAZSOCFORN");
        var filial = filtroWidget.getField("DSFILIRECE");

        filial.value(null);

        cliente.value(null);
        cabecalhoRow.CDCLIENTE = null;

        fornecedor.value(null);
        cabecalhoRow.CDFORNECED = null;
        cabecalhoRow.IDSITUCADA = null;
        cabecalhoRow.IDBLQNFRELAFOAF = null;

        cabecalhoRow.NRINSJURNF = null;
        cabecalhoRow.NMINSJURNF = null;
        cabecalhoRow.IDTPIJURNF = null;
    };

    this.cdfiliemitOnChange = function(lancamentoCabecalhoArgs) {
        lancamentoCabecalhoArgs.owner.field.widget.getField('NMRAZSOCCLIE').reload();
        CDFILIEMIT = lancamentoCabecalhoArgs.row.CDFILIEMIT;
        //validaCampoEmpresa(lancamentoCabecalhoArgs);
        validaCampoSerie(lancamentoCabecalhoArgs.row);
    };

    this.empresaOnChange = function(lancamentoCabecalhoArgs) {
         validaCampoSerie(lancamentoCabecalhoArgs.row, true);
         validaCamposDocumentoOrigem(getCabecalhoWidget(), lancamentoCabecalhoArgs.row);
    };

    this.fornecedorOnChange = function(lancamentoCabecalhoArgs) {
         validaCamposDocumentoOrigem(getCabecalhoWidget(), lancamentoCabecalhoArgs.row);
    };
    
    this.validacoesWidgetOnEnterOnce = function(consultaLancamentoArgs) {
        var cabecalhoWidget = consultaLancamentoArgs.owner;
        setDefaultFilialFilter(cabecalhoWidget).then(defaultFilter => {
            ZhFilterPreferences.setOriginalFilter(cabecalhoWidget.id, defaultFilter);
            ZhFilterPreferences.openFilterWidget(cabecalhoWidget, defaultFilter).then (response => {
                var filterWidget = templateManager.container.getActiveWidget();
                filterWidget.actions.filter(action => action.name === "clear")[0].shortcutKey = "ctrl+backspace";
            });
            CDFILIEMIT = defaultFilter.CDFILIEMIT;
            cabecalhoWidget.getField('NMTIPOOPER').reload();
        });
    };
    
    var setDefaultFilialFilter = function(cabecalhoWidget) {
        var promise = ZHPromise.defer(); 
        var defaultFilter = Util.clone(cabecalhoWidget.currentRow);
        defaultFilter.DTENTRSAID = undefined;

         General.callRestEngine('df#/filioper_lancamento_notafiscal', 'FilterData', [{"name": "CDOPERADOR", "operator": "=", "value": "OPERADOR_LOGADO"},{"name": "CDFILIAL", "operator": "=", "value": "FILIAL_LOGADA"
            }]).then(function(success){
            var defaultValue = success.dataset.filioper_lancamento_notafiscal[0]; 
            var filialField = cabecalhoWidget.getField('NMFILIAL');
            var dtEntrField = cabecalhoWidget.getField('DTENTRSAID');
            var filialOutData = filialField.outData;
            var filialOut = defaultValue.CDFILIAL;
            Df11000_Lancamento_Service.buscaDataProcessamento(filialOut).then(([processamento]) => {
                const dtProcessFormat = moment(processamento.DTPROCESSA, 'DD/MM/YYYY').format('DD/MM/YYYY');
                defaultFilter.DTENTRSAID = {start: dtProcessFormat, period: undefined, end: dtProcessFormat};
                promise.resolve(defaultFilter);
            });
    
            setCurrentRowWithOutData(defaultFilter, defaultValue, filialOutData);
            
            
        });
        
        return promise;
    };
    
    var setCurrentRowWithOutDataFilial = function(filialOut, filialField, currentRow, dtEntrField) {
        var promise = ZHPromise.defer(); 
        General.callRestEngine('df#/crud/filioper_lancamento_notafiscal', 'FilterData', [{"name": "CDFILIAL", "operator": "=", "value": filialOut}]).then(function(success){
            var defaultValue = success.dataset.filial[0]; 
            var filialOutData = filialField.outData;
            Df11000_Lancamento_Service.buscaDataProcessamento(filialOut).then(([processamento]) => {
                const dtProcessFormat = moment(processamento.DTPROCESSA, 'DD/MM/YYYY').format('DD/MM/YYYY');
                currentRow.DTENTRSAID = {start: dtProcessFormat, period: undefined, end: dtProcessFormat};
                promise.resolve();
            });
    
            setCurrentRowWithOutData(currentRow, defaultValue, filialOutData);
            
            
        });
        return promise;
    };
    
    this.getDataProcessamento = function(filialSelecionada){
        var promise = ZHPromise.defer();
        Df11000_Lancamento_Service.buscaDataProcessamento(filialSelecionada).then(function(processamento){
            var dtProcessFormat = moment(processamento[0].DTPROCESSA, 'DD/MM/YYYY').format('DD/MM/YYYY');
            promise.resolve(dtProcessFormat);
        });
        return promise;
    };
    
    var setCurrentRowWithOutData = function(currentRow, valuesToSetOnCurrentRow, outDataValue) {
        for (var key in outDataValue) {
            currentRow[outDataValue[key]] = valuesToSetOnCurrentRow[key];
        }
    };
    
    this.setDefaultNovaNota = function (args) {
        var row = {CDFILIAL: args.e.preference.FILTER_ROW.CDFILIEMIT, IDENTRSAIDOP: 'S'};
        General.callRestEngine("df#/getDefaultLancamentoNota", "Row", row).then((success) => {
            Df11000_Lancamento_Service.setDefaultNovaNotaSaida(success.dataset.defaultNovaNota);
        });
    };
    
    const reloadSerie = widget => {
        const field = widget.getField('DSSERIE');
        field.reload();
    };
    
    const reloadCampoTipoOperacao = widget => {
        var deferred = ZHPromise.defer();
        const field = widget.getField('NMTIPOOPER');
        field.reload().then(() => {
                var data = field.dataSource.data;
                if (!data || !data.length)
                    return false;

                const {currentRow} = field.widget;
                const defaultRow = data.find(operacao => operacao.CDTIPOOPER === '01');
                if(defaultRow)
                    setCurrentRowWithOutData(currentRow, defaultRow, field.outData);
                else
                    field.value(null);
                field.change();
                deferred.resolve();
            });
        return deferred;
    };
    
    var setCamposDefaultValueCabecalho = function(lancamentoCabecalhoArgs) {
        var deferred = ZHPromise.defer();
        Df11000_Lancamento_Service.getDefaultNovaNotaSaida().then((defaultNota) => {
            lancamentoCabecalhoArgs.owner.widget.currentRow.NMFILIAL = defaultNota[0].NMFILIAL;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDFILIEMIT = defaultNota[0].CDFILIEMIT;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NMEMPRESA = defaultNota[0].NMEMPRESA;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDEMPRESA = defaultNota[0].CDEMPRESA;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDINSCESTA = defaultNota[0].CDINSCESTA;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDINSCMUNI = defaultNota[0].CDINSCMUNI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDSERIE = defaultNota[0].CDSERIE;
            lancamentoCabecalhoArgs.owner.widget.currentRow.DSSERIE = defaultNota[0].DSSERIE;
            lancamentoCabecalhoArgs.owner.widget.currentRow.OPERADOR = defaultNota[0].CDOPERADOR;
            lancamentoCabecalhoArgs.owner.widget.currentRow.IEREM = defaultNota[0].CDINSCESTA;
            lancamentoCabecalhoArgs.owner.widget.currentRow.SGESTADOREM = defaultNota[0].SGESTADO;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NMMUNICIPIOREM = defaultNota[0].NMMUNICIPIO;
            lancamentoCabecalhoArgs.owner.widget.currentRow.DSENDEREM = defaultNota[0].DSENDEFILI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NMBAIRREM = defaultNota[0].NMBAIRFILI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NRCEPREM = defaultNota[0].NRCEPFILI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NRTELEREM = defaultNota[0].NRTELEFILI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDOPERGERA = defaultNota[0].CDOPERADOR;
            lancamentoCabecalhoArgs.owner.widget.currentRow.DTENTRSAID = defaultNota[0].DTENTRSAID;
            
            reloadCampoTipoOperacao(lancamentoCabecalhoArgs.owner.widget);
            reloadSerie(lancamentoCabecalhoArgs.owner.widget);

            
            validaCampoSerie(lancamentoCabecalhoArgs.row);
            deferred.resolve();
        });
        return deferred;
    };

/*    var setCamposDefaultValueCabecalho = function(lancamentoCabecalhoArgs) {
        var deferred = ZHPromise.defer();
        Df11000_Lancamento_Service.buscaOperadorLogado().then(function(operador){
            var defaultValue = lancamentoCabecalhoArgs.owner.widget.getField('NMFILIAL').dataSource.data.filter(function(data) {
                //@todo filial logada
                return data.CDFILIAL == operador[0].CDFILIALSELECIONADA;
            });
            defaultValue = defaultValue[0];
            lancamentoCabecalhoArgs.owner.widget.currentRow.NMFILIAL = defaultValue.NMFILIAL;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDFILIEMIT = defaultValue.CDFILIAL;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NMEMPRESA = defaultValue.NMEMPRESA;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDEMPRESA = defaultValue.CDEMPRESA;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDINSCESTA = defaultValue.CDINSCESTA;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDINSCMUNI = defaultValue.CDINSCMUNI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.CDSERIE = defaultValue.CDSERIE;
            lancamentoCabecalhoArgs.owner.widget.currentRow.DSSERIE = defaultValue.DSSERIE;
            lancamentoCabecalhoArgs.owner.widget.currentRow.OPERADOR = defaultValue.CDOPERADOR;
            lancamentoCabecalhoArgs.owner.widget.currentRow.IEREM = defaultValue.CDINSCESTA;
            lancamentoCabecalhoArgs.owner.widget.currentRow.SGESTADOREM = defaultValue.SGESTADO;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NMMUNICIPIOREM = defaultValue.NMMUNICIPIO;
            lancamentoCabecalhoArgs.owner.widget.currentRow.DSENDEREM = defaultValue.DSENDEFILI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NMBAIRREM = defaultValue.NMBAIRFILI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NRCEPREM = defaultValue.NRCEPFILI;
            lancamentoCabecalhoArgs.owner.widget.currentRow.NRTELEREM = defaultValue.NRTELEFILI;

            Df11000_Lancamento_Service.buscaDataProcessamento(operador[0].CDFILIALSELECIONADA).then(function(processamento){
                var dtProcess = processamento[0].DTPROCESSA;
                var dtProcessFormat = moment(dtProcess, 'DD/MM/YYYY').format('DD/MM/YYYY');
                                var today = moment().format('DD/MM/YYYY');
                                var nowFullTime = moment().format('DD/MM/YYYY');
                                if(dtProcessFormat === today){
                                  dtProcessFormat = nowFullTime;
                                }else{
                                    dtProcessFormat = moment(dtProcess, 'DD/MM/YYYY').format('DD/MM/YYYY');
                                }
                lancamentoCabecalhoArgs.owner.widget.currentRow.DTENTRSAID = dtProcessFormat;
            });

            validaCampoSerie(lancamentoCabecalhoArgs.row);
            deferred.resolve();
        });
        return deferred;
    };*/

    this.cancelaEdicaoCabecalho = function(args){
        General.backOrCancel(args).then(function(){
            alteraVisibilidadeCampoInscricao();
            controlaStatusWidgets(args.owner.widget, args.owner.widget.name, true);
        });
    };
    
    this.dateOnChange = function(dateField){
        var today = moment().format('DD/MM/YYYY');
        var nowFullTime = moment().format('DD/MM/YYYY');
        if(moment(dateField.value(), 'DD/MM/YYYY').format('DD/MM/YYYY') === today)
            dateField.value(nowFullTime);
    };

    var alteraVisibilidadeCampoInscricao = function(widget) {
        widget =  !widget ? getCabecalhoWidget() : widget  ; 
        var cabecalhoWidget = getCabecalhoWidget();
        var cabecalhoCurrentRow = widget.currentRow;
        var cliente = widget.getField("NMRAZSOCCLIE");
        var fornecedor = widget.getField("NMRAZSOCFORN");
        var filial = widget.getField("DSFILIRECE");
        var tipoDestino = cabecalhoCurrentRow.IDORIGDESTOP || cabecalhoCurrentRow.IDORIGDESTNF;

        switch (tipoDestino) {
            case "C":
                validacaoCamposOutTpOperac(cliente, fornecedor, filial);
                break;
            case "F":
                validacaoCamposOutTpOperac(fornecedor, cliente, filial);
                break;
            case "L":
                validacaoCamposOutTpOperac(filial, fornecedor, cliente);
                break;
            default:
                filial.readOnly = true;
                cliente.readOnly = true;
                fornecedor.readOnly = true;
        }
    };

    this.actNovoDadosAdicionaisOnClick = function(args) {
        args.owner.widget.newRow();
        Df11000_Lancamento_Service.getProxSeqDadosAdicionais().then(function(nrdadoadic){
           args.owner.widget.currentRow.NRDADOADIC = nrdadoadic;
        });
    };

    this.actEditarDadosAdicionaisOnClick = function(detalhesDadosAdicionaisWidget) {
        General.edit(detalhesDadosAdicionaisWidget);
    };

    this.limpaCampoCodigoDadosAdic = function(dadosAdicArgs) {
        dadosAdicArgs.row.CDMENSAGEM = null;
    };

    this.actIncluirDadosAdicionaisOnClick = function(lancamentoDadosAdicionaisArgs) {
         if (lancamentoDadosAdicionaisArgs.owner.widget.isValid()) {
            lancamentoDadosAdicionaisArgs.row.NRLANCTONF = lancamentoDadosAdicionaisArgs.owner.widget.getParent().currentRow.NRLANCTONF;
            lancamentoDadosAdicionaisArgs.row.CDFILIAL = lancamentoDadosAdicionaisArgs.owner.widget.getParent().currentRow.CDFILIAL;

            Df11000_Lancamento_Service.salvaDadosAdicionais(lancamentoDadosAdicionaisArgs.row).then(function() {
                alteraStatusNotafiscal(lancamentoDadosAdicionaisArgs.owner.widget);
                var closeSwipe = lancamentoDadosAdicionaisArgs.row.__is_new === true;
                //@todo remover __is_new quando widget.edit() funcionar
                lancamentoDadosAdicionaisArgs.row.__is_new = false;
                Df11000_Lancamento_Service.setDataSourceDadosAdicionais(lancamentoDadosAdicionaisArgs.row).then(function(){
                    Df11000_Lancamento_Service.atualizaLancamento().then(function(){
                        Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                        General.backOrCancel(lancamentoDadosAdicionaisArgs);
                        if(closeSwipe)
                            ScreenService.closeSwipe();
                        lancamentoDadosAdicionaisArgs.owner.widget.reload();
                    });
                });
            }, requestError);
         }
    };

    this.actExcluirDadosAdicionaisOnClick = function(lancamentoDadosAdicionaisArgs) {
        ScreenService.confirmMessage('Deseja excluir a mensagem?', 'question', function (success) {
            Df11000_Lancamento_Service.excluiDadosAdicionais(lancamentoDadosAdicionaisArgs.row).then(function () {
                alteraStatusNotafiscal(lancamentoDadosAdicionaisArgs.owner.widget);
                Df11000_Lancamento_Service.excluiDadosAdicionaisDataSource(lancamentoDadosAdicionaisArgs.row.NRDADOADIC).then(function () {
                    Df11000_Lancamento_Service.atualizaLancamento().then(function () {
                        Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                        General.backOrCancel(lancamentoDadosAdicionaisArgs);
                        lancamentoDadosAdicionaisArgs.owner.widget.reload();
                    });
                });
            }, requestError);
        });
    };

    this.setDtsEncargoOnEnter = function(lancamentoEncargoArgs) {
        if((lancamentoEncargoArgs.owner.getParent().currentRow.IDSTATUS === "D") && (!lancamentoEncargoArgs.owner.dataSource.data || !lancamentoEncargoArgs.owner.dataSource.data.length)){
            Df11000_Lancamento_Service.buscaEncargosPadrao().then(function(encargos){
                encargos.forEach(function(encargo){
                    encargo.VRITEMENCA = 0;
                    encargo.NRLANCTONF = lancamentoEncargoArgs.owner.getParent().currentRow.NRLANCTONF;
                    encargo.CDFILIAL = lancamentoEncargoArgs.owner.getParent().currentRow.CDFILIAL;
                    encargo.VRENMOEDESTR = "";
                    encargo.IDALTERADO = "N";
                    encargo.__is_new = true;
                });
                Df11000_Lancamento_Service.setDataSourceEncargo(encargos).then(function(){
                    lancamentoEncargoArgs.owner.currentRow = encargos;
                    lancamentoEncargoArgs.owner.reload();
                });
            }, requestError);
        }
    };

    this.salvaEncargoInlineEdit = function(lancamentoEncargoArgs) {
        var encargosSalvar;
         if (lancamentoEncargoArgs.owner.isValid()) {
         //    GerUtil.desmarcaLinhasEditadas(lancamentoEncargoOwner, SALVAR);
             if(lancamentoEncargoArgs.row.__is_new === true){
                 encargosSalvar = lancamentoEncargoArgs.owner.dataSource.data;
             }
             else{
                 encargosSalvar = lancamentoEncargoArgs.dataSource.filter(function(encargo){
                    return encargo.changed === true;
                });
             }

            Df11000_Lancamento_Service.salvaEncargo(encargosSalvar).then(function(){
                alteraStatusNotafiscal(lancamentoEncargoArgs.owner);
                encargosSalvar.forEach(function(encargo){
                    encargo.__is_new = false;
                    //@todo remover delete encargo.changed quando desmarcaLinhasEditadas for implementada
                    delete encargo.changed_VRITEMENCA;
                    delete encargo.changed;
                });
                Df11000_Lancamento_Service.setDataSourceEncargo(lancamentoEncargoArgs.dataSource).then(function(){
                    Df11000_Lancamento_Service.atualizaLancamento().then(function(){
                        //@todo desmarcaLinhasEditadas
                        //GerUtil.desmarcaLinhasEditadas(lancamentoEncargoWidget, CANCELAR);
                        Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                        lancamentoEncargoArgs.owner.view();
                        lancamentoEncargoArgs.owner.reload();
                        controlaStatusWidgets(lancamentoEncargoArgs.owner.getParent(), lancamentoEncargoArgs.owner.name, true);
                    });
                });
            }, requestError);
         }
    };

    this.cancelaEncargoInlineEdit = function(lancamentoEncargoWidget) {
         //GerUtil.desmarcaLinhasEditadas(lancamentoEncargoWidget, CANCELAR);
         //delete encargo["changed_VRITEMENCA"];
         //delete encargo.changed;
        lancamentoEncargoWidget.dataSource.data.forEach(function(encargo){
            delete encargo.changed_VRITEMENCA;
            delete encargo.changed;
        });
        lancamentoEncargoWidget.view();
        controlaStatusWidgets(lancamentoEncargoWidget.getParent(), lancamentoEncargoWidget.name, true);
    };

    /* this.validaEncargoWizardBeforeNextStage = function(lancamentoSaidaEncargoArgs) {
    //     /* Remover todas acões relacionadas a variavel "nextStage" quando o processo de
    //      * "WizardBeforeNextStage, WizardAfterNextStage" se tornar síncrono
    //      * /
    //     if (!nextStage) {
    //         lancamentoSaidaEncargoArgs.e.preventDefault();

    //         LancamentoNFSaidaEncargoService.validaEncargoMaiorQuantItens().then(function() {
    //             nextStage = true;
    //             wizardEngine.next().then(function() {
    //                 nextStage = false;
    //             });
    //         }, function(error) {
    //             ScreenService.showMessage(error);
    //         });
    //     }
    // }; */
    
    const modificaDatasourceFilterProdutoServico = action => {
        const field = action.widget.getField('NMPRODUTO');

        field.dataSourceFilter = field.dataSourceFilter.filter(filter => filter.name != 'CDCLIENTE');

        if(action.name === 'novoServico'){
            field.dataSource.name = 'df_saida#/crud/servclie_servico_produto';

            const cliente = action.widget.getParent().currentRow.CDCLIENTE;
            const filterCdcliente = {
                name: 'CDCLIENTE',
                operator: '=',
                value: cliente
            };

            field.dataSourceFilter = [...field.dataSourceFilter, filterCdcliente];
            field.fields[0].isVisible = false;
            field.fields[1].isVisible = false;
            field.fields[2].isVisible = true;
            field.fields[3].isVisible = true;
            
            field.displayedFields       =  ["CDSERVFILI", "NMSERVICO"];
            field.searchableFields      =  ["CDSERVFILI", "NMSERVICO"];
            delete field.outData.NMPRODUTO;
            field.outData.NMSERVICO     = ['NMPRODUTO', 'NMSERVICO'];
            field.descriptionField      = 'NMSERVICO';
        } else if(action.name === 'novoItem') {
            field.dataSource.name = 'df#/produtoLancamento';
            field.fields[0].isVisible = true;
            field.fields[1].isVisible = true;
            field.fields[2].isVisible = false;
            field.fields[3].isVisible = false;
            field.displayedFields       =  ["CDARVPROD", "NMPRODUTO"];
            field.searchableFields =  ["CDARVPROD", "NMPRODUTO"];
            delete field.outData.NMPRODUTO;
            field.outData.NMPRODUTO     = 'NMPRODUTO';
            field.descriptionField  = 'NMPRODUTO';
        }

        field.dataSource.data = [];
        field.reload();

        return field.dataSource.name;
    };

    var verificaTipoItemProdutoServico = function(widget){
        if(widget.getParent().currentRow.IDOPERDEVONF !== "S"){
            if(widget.getParent().appliedFilter.FILTER_ROW.IDBLOQITNFAPUR !== "S"){
                if(widget.getField("NMPRODUTO").dataSource.name === "df#/produtoLancamento"){
                    widget.getAction("novoItem").isVisible = true;
                    widget.getAction("novoServico").isVisible = false;

                }
                else{
                    widget.getAction("novoItem").isVisible = false;
                    widget.getAction("novoServico").isVisible = true;
                }
            }
            else{
                widget.getAction("novoItem").isVisible = true;
                widget.getAction("novoServico").isVisible = false;
            }
        }
    };

    this.actNovoItemOnClick = function(args) {
        var itemWidget = args.owner.widget;
        var parentWidget = itemWidget.getParent();
        var dataSourceName = modificaDatasourceFilterProdutoServico(args.owner);

        var filter = [
            {
                'name': 'CDFILIAL', 
                'operator': '=', 
                'value': args.owner.widget.getParent().currentRow.CDFILIEMIT
            }
        ];
        
        General.callRestEngine('df#/crud/paramfilial', 'FilterData', filter).then(function(params){
            if((params.dataset.paramfilial[0].IDPERPROINAT == 'N') || (params.dataset.paramfilial[0].IDPERPROINAT == null)){
                var idproativpr = 
                {
                    "name": "IDPRODATIVPR",
                    "operator": "=",
                    "value": "S"
                };
                var idproatv = 
                {
                    "name": "IDPRODATIV",
                    "operator": "=",
                    "value": "A" 
                };
                //templateManager.container.getWidget('itens').getField('NMPRODUTO').dataSourceFilter.push(idproativpr);
                //templateManager.container.getWidget('itens').getField('NMPRODUTO').dataSourceFilter.push(idproatv);
            }/* else{
                var dataSourceFilter = templateManager.container.getWidget('itens').getField('NMPRODUTO').dataSourceFilter;
                if(dataSourceFilter.length > 2){
                    dataSourceFilter.pop();
                    dataSourceFilter.pop();
                }
            }*/
        });
        
        if(dataSourceName === "df_saida#/crud/servclie_servico_produto") {
            var controlaMaxItens = parentWidget.currentRow.IDCONMAXITEM;
            var numMaxServicos = parentWidget.currentRow.NRMAXITNF;
            if(controlaMaxItens != "N" && args.owner.widget.dataSource.data.length >= numMaxServicos)
                return ScreenService.showMessage("Foi alcançada a quantidade máxima de serviços no lançamento");
            itemWidget.label = 'Serviços';
        }

        itemWidget.newRow();
        Df11000_Lancamento_Service.getProxSeqItens().then(function(nrseqitprod){
            itemWidget.currentRow.NRSEQITPROD = nrseqitprod;
            controlaStatusWidgets(itemWidget, itemWidget.name, false);
        });
        General.justInteger('#NRSEQPEDPROD');
    };

    var habilitaCamposCabecalhoNotaOrigem = function(cabecalhoWidget, lancamentoCabecalhoRow){
        var verificaUtilizaNotaOrigem = lancamentoCabecalhoRow.IDOPERDEVONF === "S";
        var serieOrigem = cabecalhoWidget.getField("CDSERIEORIGEM");
        var notaOrigem = cabecalhoWidget.getField("DSNOTAORIGEM");

        if(verificaUtilizaNotaOrigem){
            serieOrigem.required = true;
            notaOrigem.required = true;
            serieOrigem.isVisible = true;
            serieOrigem.readOnly = true;
            notaOrigem.isVisible = true;
        }
        else
        {
            delete serieOrigem.required;
            delete notaOrigem.required;
            serieOrigem.isVisible = false;
            notaOrigem.isVisible = false;
        }
    };

    var habilitaCamposItemNotaOrigem = function(lancamentoItensWidget, lancamentoCabecalhoRow) {
        var verificaUtilizaNotaOrigem = lancamentoCabecalhoRow.IDOPERDEVONF === "S";

        if(verificaUtilizaNotaOrigem){
            delete lancamentoItensWidget.getField('QTITEMPROD').required;
        }
        else
        {
            lancamentoItensWidget.getField('QTITEMPROD').required = true;
        }

        lancamentoItensWidget.getField('QTITEMPRODORIG').isVisible = verificaUtilizaNotaOrigem;
        lancamentoItensWidget.getField('VRUNITITEM').readOnly = verificaUtilizaNotaOrigem;
        lancamentoItensWidget.getField('VRDESCITEM').readOnly = verificaUtilizaNotaOrigem;
        lancamentoItensWidget.getField('NMPRODUTO').readOnly = verificaUtilizaNotaOrigem;
        lancamentoItensWidget.getField('CDPRODEMIS').readOnly = verificaUtilizaNotaOrigem;
        lancamentoItensWidget.getField('DSPRODEMIS').readOnly = verificaUtilizaNotaOrigem;
        lancamentoItensWidget.getField('VRTOTAITEM').readOnly = verificaUtilizaNotaOrigem;
        lancamentoItensWidget.getField('DSINFADICPROD').readOnly = verificaUtilizaNotaOrigem;

        if(lancamentoCabecalhoRow.IDSTATUS !== "A" && lancamentoCabecalhoRow.IDSTATUS !== "C"){
            lancamentoItensWidget.getAction('novoItem').isVisible = !verificaUtilizaNotaOrigem;
            lancamentoItensWidget.getAction('excluirItem').isVisible = !verificaUtilizaNotaOrigem;
        }

        //if (verificaUtilizaNotaOrigem) {
        //    lancamentoItensWidget.getField('QTITEMPRODORIG').class = 4;
        //    lancamentoItensWidget.getField('QTITEMPROD').class = 4;
        //    lancamentoItensWidget.getField('VRUNITITEM').class = 4;
        //} else {
        //    lancamentoItensWidget.getField('QTITEMPRODORIG').class = 12;
        //    lancamentoItensWidget.getField('QTITEMPROD').class = 6;
        //    lancamentoItensWidget.getField('VRUNITITEM').class = 6;
        //}
    };

    this.actCancelarEdicaoItem = function(args){
        General.backOrCancel(args);
        var widget = args.owner.widget;
        widget.reload();
        let servicos = false; 
        widget.label = 'Produtos';
        controlaStatusWidgets(args.owner.widget, args.owner.widget.name, true);
    };

    this.actIncluirItemOnClick = function(lancamentoItemArgs) {
        lancamentoItemArgs.owner.widget.label = 'Produtos';
         if (lancamentoItemArgs.owner.widget.isValid()) {
             lancamentoItemArgs.row.NRLANCTONF = lancamentoItemArgs.owner.widget.getParent().currentRow.NRLANCTONF;
             lancamentoItemArgs.row.CDFILIAL = lancamentoItemArgs.owner.widget.getParent().currentRow.CDFILIAL;
             lancamentoItemArgs.row.IDATUVRESTOQ = 'S';
             lancamentoItemArgs.row.VRCONTITEM = '0';
             lancamentoItemArgs.row.IDCONFORITEM = 'S';
             lancamentoItemArgs.row.VRBRUTITEM = '0';
             if(!lancamentoItemArgs.row.VRDESCITEM){
                 lancamentoItemArgs.row.VRDESCITEM = '0';
             }

             if(Df11000_Lancamento_Service.verificaUtilizaNotaOrigem(lancamentoItemArgs.owner.widget.getParent().currentRow) && lancamentoItemArgs.row.QTITEMPROD === "0" && lancamentoItemArgs.row.__is_new === false){
                 Df11000_Lancamento_Service.excluiItem(lancamentoItemArgs.row).then(function() {
                     lancamentoItemArgs.row.__is_new = true;
                     Df11000_Lancamento_Service.setDataSourceItem(lancamentoItemArgs.row).then(function () {
                         Df11000_Lancamento_Service.atualizaLancamento().then(function () {
                             Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                             lancamentoItemArgs.owner.widget.view();
                             //General.backOrCancel(lancamentoItemArgs);
                             lancamentoItemArgs.owner.widget.reload();
                             controlaStatusWidgets(lancamentoItemArgs.owner.widget, lancamentoItemArgs.owner.widget.name, true);
                         });
                     });
                 }, requestError);
             }
             else{
                 Df11000_Lancamento_Service.salvaItem(lancamentoItemArgs.owner.widget.getParent().currentRow, lancamentoItemArgs.row).then(function(){
                     alteraStatusNotafiscal(lancamentoItemArgs.owner.widget);
                     //lancamentoItemArgs.owner.widget.getParent().currentRow.IDSTATUS = 'D';
                     var closeSwipe = lancamentoItemArgs.row.__is_new === true;
                     //@todo remover __is_new quando widget.edit() funcionar
                     lancamentoItemArgs.row.__is_new = false;
                     verificaTipoItemProdutoServico(lancamentoItemArgs.owner.widget);
                     Df11000_Lancamento_Service.setDataSourceItem(lancamentoItemArgs.row).then(function(){
                         Df11000_Lancamento_Service.atualizaLancamento().then(function(){
                             Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                             lancamentoItemArgs.owner.widget.view();
                             //General.backOrCancel(lancamentoItemArgs);
                             if(closeSwipe)
                                 ScreenService.closeSwipe();
                             lancamentoItemArgs.owner.widget.reload();
                             controlaStatusWidgets(lancamentoItemArgs.owner.widget, lancamentoItemArgs.owner.widget.name, true);
                         });
                     });
                 }, function(error) {
                    if (Array.isArray(error)) {
                        var stringCamposObrig = error.join(', ');
                        var mensagem = "CAMPOS_MAIORES_ZERO";
                        MessageService.showMessageByCode(mensagem, {"PARAMETRO": stringCamposObrig});
                    } else if (typeof error === 'string')
                        ScreenService.showMessage(error);
                    ScreenService.showMessage(error.data.error);
                });
             }
         }
    };

    this.actEditarItemOnClick = function(detalhesItemWidget) {
        if(Df11000_Lancamento_Service.verificaUtilizaNotaOrigem(detalhesItemWidget.getParent().currentRow)){
            Df11000_Lancamento_Service.buscaQuantidadeDevolvida(detalhesItemWidget.getParent().currentRow, detalhesItemWidget).then(function(data) {
                detalhesItemWidget.currentRow.QTITEMDEVO = data.length !== 0 ? data[0].QTITEMDEVO : "0";
                detalhesItemWidget.currentRow.QTITEMPRODBEFOREEDIT = detalhesItemWidget.currentRow.QTITEMPROD;
                General.edit(detalhesItemWidget);
            }, function(error) {
                if (!!error)
                    ScreenService.showMessage('Ocorreu um erro ao buscar a quantidade de itens disponíveis.' + error.data.error);
            });
        }
        else{
            General.edit(detalhesItemWidget);
        }
        General.justInteger('#NRSEQPEDPROD');
    };

    this.actExcluirItemOnClick = function(lancamentoItemArgs) {
        ScreenService.confirmMessage('Deseja excluir o item?', 'question', function (success) {
            Df11000_Lancamento_Service.excluiItem(lancamentoItemArgs.row).then(function(){
                alteraStatusNotafiscal(lancamentoItemArgs.owner.widget);
                Df11000_Lancamento_Service.excluiItemDataSource(lancamentoItemArgs.row.NRSEQITPROD).then(function(){
                    Df11000_Lancamento_Service.atualizaLancamento().then(function(){
                        Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                        General.backOrCancel(lancamentoItemArgs);
                        lancamentoItemArgs.owner.widget.reload().then(function(){
                            verificaTipoItemProdutoServico(lancamentoItemArgs.owner.widget);
                        });
                    });
                });
            }, requestError);
        });
    };

    var setValoresEmissaoProdutoOnChange = function(lancamentoItemArgs) {
        if(lancamentoItemArgs.row.CDSERVFILI) {
            General.callRestEngine("df#/crud/paramgeral", "FilterData", []).then(function(success) {
                var resul = success.dataset.paramgeral;
                if(resul[0].IDUTPROPEMIS == 'S') {
                    lancamentoItemArgs.row.CDPRODEMIS = lancamentoItemArgs.row.CDARVPROD;
                    lancamentoItemArgs.row.DSPRODEMIS = lancamentoItemArgs.row.NMPRODUTO;
                }
                else {
                    lancamentoItemArgs.row.CDPRODEMIS = lancamentoItemArgs.row.CDSERVFILI;
                    if(lancamentoItemArgs.row.DSEMISSERCLI) {
                        lancamentoItemArgs.row.DSPRODEMIS = lancamentoItemArgs.row.DSEMISSERCLI;
                    }
                    else {
                        lancamentoItemArgs.row.DSPRODEMIS = lancamentoItemArgs.row.NMSERVICO;
                    }
                }
            });
        }
        else {
            lancamentoItemArgs.row.CDPRODEMIS = lancamentoItemArgs.row.CDARVPROD;
            lancamentoItemArgs.row.DSPRODEMIS = lancamentoItemArgs.row.NMPRODUTO;
        }
    };
    
    var consultaCustoQuantidadeProdutoOnChange = function(lancamentoItemArgs) {
         var filial = lancamentoItemArgs.owner.field.widget.getParent().currentRow.CDFILIEMIT;
         var dtLancamento = lancamentoItemArgs.owner.field.widget.getParent().currentRow.DTENTRSAID;
         var produto = lancamentoItemArgs.row.CDPRODUTO;
         var operacao = lancamentoItemArgs.owner.field.widget.getParent().currentRow.CDTIPOOPER;

         lancamentoItemArgs.row.VRUNITITEM = "";
         lancamentoItemArgs.row.QTITEMPROD = "";
         lancamentoItemArgs.row.VRTOTAITEM = "";

        if (produto) {
            if(lancamentoItemArgs.row.CDSERVFILI) {
                lancamentoItemArgs.row.VRUNITITEM = lancamentoItemArgs.row.VRSERVFATU;
            }
            else {
                ValidacoesEstoque_Service.consultaCustoQuantidadeProduto(filial, produto, dtLancamento, null , null, null, null, null , operacao).then(function(custoQuant) {
                    custoQuant = custoQuant.dataset.consultaCustoQuantidadeProduto.VRCUSTOPROD;
                    lancamentoItemArgs.row.VRUNITITEM = typeof(custoQuant) === "string" ? parseFloat(custoQuant) : custoQuant;
                }, requestError);
            }
        }
    };

    var informacoesComplementaresProduto = function(lancamentoItemArgs){
        lancamentoItemArgs.row.CDFILIMOVI = templateManager.container.getWidget('cabecalho').currentRow.CDFILIEMIT;
        Lib00206_InfComplProduto_Controller.infComplementares(lancamentoItemArgs.owner.field.widget, lancamentoItemArgs.row, false);
    };

    this.validacoesProdutoOnChange = function(lancamentoItemArgs) {
        setValoresEmissaoProdutoOnChange(lancamentoItemArgs);
        consultaCustoQuantidadeProdutoOnChange(lancamentoItemArgs);
        informacoesComplementaresProduto(lancamentoItemArgs);
    };

    this.afterCancelInfoCompl = function(args){
        args.owner.widget = args.owner;
        this.actCancelarEdicaoItem(args);
    };

    var calculaValorTotal = function(lancamentoItemArgs) {
        if(Df11000_Lancamento_Service.verificaUtilizaNotaOrigem(getCabecalhoWidget().currentRow) && lancamentoItemArgs.row.QTITEMPROD === "0"){
            lancamentoItemArgs.row.VRTOTAITEM = lancamentoItemArgs.row.VRUNITITEM;
        }
        else{
            lancamentoItemArgs.row.VRTOTAITEM = Df11000_Lancamento_Service.calculaValorTotal(
                lancamentoItemArgs.row.QTITEMPROD, lancamentoItemArgs.row.VRUNITITEM
            );
        }
    };

    this.valorUnitarioFieldOnChange = function(lancamentoItemArgs) {
         lancamentoItemArgs.row.VRUNITITEM =  typeof(lancamentoItemArgs.row.VRUNITITEM) === "string" ? parseFloat(lancamentoItemArgs.row.VRUNITITEM.replace(/[.]+/g, '').replace("," , ".")): lancamentoItemArgs.row.VRUNITITEM;
         calculaValorTotal(lancamentoItemArgs);
    };

    this.quantidadeFieldOnChange = function(lancamentoItemArgs) {
        /* Se QTESTOQDIA não exister na row significa que a "Informações Complementares de Produto" não foi aberta
        porntanto, trat-ase de um produto que não controla estoque ou a operação está sendo feita com uma filial
        que não controla estoque, logo a validação de quantidade não deve ser feita. */
        if(lancamentoItemArgs.row.QTESTOQDIA && parseFloat(lancamentoItemArgs.row.QTITEMPROD) > lancamentoItemArgs.row.QTESTOQDIA) {
            MessageService.showMessageByCode("QUANTIDADE_ESTOQUE",{"QTESTOQDIA": parseFloat(lancamentoItemArgs.row.QTESTOQDIA), "SGUNIDADE": parseFloat(lancamentoItemArgs.row.SGUNIDADE)});
            lancamentoItemArgs.row.QTITEMPROD = 0.00;
        }
        else{
           
            lancamentoItemArgs.row.QTITEMPROD =  typeof(lancamentoItemArgs.row.QTITEMPROD) === "string" ? parseFloat(lancamentoItemArgs.row.QTITEMPROD.replace(/[.]+/g, '').replace("," , ".")): lancamentoItemArgs.row.QTITEMPROD;
            calculaValorTotal(lancamentoItemArgs);
        } 
    };

    this.valorTotalFieldOnChange = function(lancamentoItemArgs) {
         lancamentoItemArgs.row.VRUNITITEM = Df11000_Lancamento_Service.calculaValorUnitario(
             lancamentoItemArgs.row.QTITEMPROD, lancamentoItemArgs.row.VRTOTAITEM
         );
    };

    var buscaItensNotaOrigem = true;

    this.setDtsItensNotaOrigemOnEnter = function(lancamentoItensArgs) {
        if(buscaItensNotaOrigem && Df11000_Lancamento_Service.verificaUtilizaNotaOrigem(lancamentoItensArgs.owner.getParent().currentRow)){
            Df11000_Lancamento_Service.buscaItensNotaOrigem(lancamentoItensArgs.owner.getParent().currentRow).then(function(itens) {
                itens.forEach(function(item){
                    var itemJaSalvo = lancamentoItensArgs.owner.dataSource.data.filter(function(data){
                        if(data.NRSEQITPROD === item.NRSEQITPROD)
                            data.QTITEMPRODORIG = item.QTITEMPRODORIG;
                        return data.NRSEQITPROD === item.NRSEQITPROD;
                    });
                    if(itemJaSalvo.length > 0){
                        var index = itens.indexOf(item);
                        itens.splice(index, 1);
                    }
                    else{
                        item.__is_new = true;
                        lancamentoItensArgs.owner.dataSource.data.push(item);
                    }
                });
                buscaItensNotaOrigem = false;
                if(lancamentoItensArgs.owner.getParent().currentRow.IDSTATUS === 'D') {
                    Df11000_Lancamento_Service.setDataSourceItem(itens).then(() => {
                        Df11000_Lancamento_Service.atualizaLancamento().then(lancamentoItensArgs.owner.reload());
                    });
                }
                
            }, function(error) {
                lancamentoItensArgs.owner.reload();
            });
        }
    };

    this.actNovoVencimentoOnClick = function(args) {
        args.owner.widget.newRow();
        Dfs11000_LancamentoSaida_Service.getProxSeqVencimento().then(function(nrseqvenrec){
            args.owner.widget.currentRow.NRSEQVENREC = nrseqvenrec;
        });
        setMinMaxDateVencimento(args.owner.widget);
    };

    this.actEditarVencimentoOnClick = function(detalhesVencimentoWidget) {
        setMinMaxDateVencimento(detalhesVencimentoWidget);
        General.edit(detalhesVencimentoWidget);
    };

    var setMinMaxDateVencimento = function(widget) {
        var parentCurrentRow = widget.getParent().currentRow;
        var parentDate = moment(parentCurrentRow.DTENTRSAID, "DD/MM/YYYY");
        var dateField = widget.getField("DTATUAVENREC");
        dateField.minDate = parentDate.format("DD/MM/YYYY");
        dateField.maxDate = parentDate.add(60, "days").format("DD/MM/YYYY");
    };

    this.actIncluirVencimentoOnClick = function(lancamentoVencimentoArgs) {
         if (lancamentoVencimentoArgs.owner.widget.isValid()) {
            var dataLancamento = lancamentoVencimentoArgs.owner.widget.getParent().currentRow.DTENTRSAID;
            var dataVencimento = lancamentoVencimentoArgs.row.DTATUAVENREC;
            var dataProcessamento = getLocalVar('DATA_PROCESSAMENTO');
            var erroDataVencimento = Df11000_Lancamento_Service.validaDataVencimento(dataLancamento, dataVencimento, dataProcessamento);

            if (erroDataVencimento)
                return ScreenService.showMessage(erroDataVencimento);

            lancamentoVencimentoArgs.row.NRLANCTONF = lancamentoVencimentoArgs.owner.widget.getParent().currentRow.NRLANCTONF;
            lancamentoVencimentoArgs.row.CDFILIAL = lancamentoVencimentoArgs.owner.widget.getParent().currentRow.CDFILIAL;
            lancamentoVencimentoArgs.row.NRPARCELAREC = '00';
            lancamentoVencimentoArgs.row.VRORIGREC = lancamentoVencimentoArgs.row.VRATUAREC;
            lancamentoVencimentoArgs.row.DTORIGVENREC = lancamentoVencimentoArgs.row.DTATUAVENREC;

            Dfs11000_LancamentoSaida_Service.salvaVencimento(lancamentoVencimentoArgs.row).then(function() {
                alteraStatusNotafiscal(lancamentoVencimentoArgs.owner.widget);
                var closeSwipe = lancamentoVencimentoArgs.row.__is_new === true;
                //@todo remover __is_new quando widget.edit() funcionar
                lancamentoVencimentoArgs.row.__is_new = false;
                Df11000_Lancamento_Service.setDataSourceVencimento(lancamentoVencimentoArgs.row).then(function(){
                    Df11000_Lancamento_Service.atualizaLancamento().then(function(){
                        Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                        lancamentoVencimentoArgs.owner.widget.view();
                        if(closeSwipe)
                            ScreenService.closeSwipe();
                        lancamentoVencimentoArgs.owner.widget.reload();
                    });
                });
            }, requestError);
         }
    };

    this.actExcluirVencimentoOnClick = function(lancamentoVencimentoArgs) {
        ScreenService.confirmMessage('Deseja excluir o vencimento?', 'question', function (success) {
            Dfs11000_LancamentoSaida_Service.excluiVencimento(lancamentoVencimentoArgs.row).then(function () {
                alteraStatusNotafiscal(lancamentoVencimentoArgs.owner.widget);
                Df11000_Lancamento_Service.excluiVencimentoDataSource(lancamentoVencimentoArgs.row.NRSEQVENREC).then(function () {
                    Df11000_Lancamento_Service.atualizaLancamento().then(function () {
                        Df11000_Lancamento_Service.setDataSourceLancamentoNota();
                        General.backOrCancel(lancamentoVencimentoArgs);
                        lancamentoVencimentoArgs.owner.widget.reload();
                    });
                });
            }, requestError);
        });
    };

    this.validaUtilizaVencimentoWidgetOnEnter = function(vencimentoSaidaArgs) {
        if(vencimentoSaidaArgs.owner.getParent().currentRow.IDSTATUS !== "A"){
            //@todo isVisible || readonly
            vencimentoSaidaArgs.owner.getAction('actNovoVencimento').isVisible = (vencimentoSaidaArgs.owner.getParent().currentRow.IDUTILVENC === 'S');
        }
    };

    this.fecharNota = function(args) {
        if(args.owner.getParent().name == 'cabecalho') var popup = true;
        ScreenService.confirmMessage('Deseja fechar a nota fiscal?', 'question', function (success) {
            Df11000_Lancamento_Service.fecharNota().then(function(callback) {
                Df11000_Lancamento_Service.geraRateio();
                if (callback) {
                    if(callback.dataset.fecharNota.ERROS_REPLICACAO){
                        ErrosReplicacaoDocumentos_Utilities.errosReplicacao(args.owner.widget, callback.dataset.fecharNota.ERROS_REPLICACAO);
                        ScreenService.showMessage("Ocorreram erros ao tentar realizar a replicação da nota fiscal.");
                    }
                    else{
                        General.backOrCancel(args);
                        var parentWidget = getCabecalhoWidget();
                        parentWidget.currentRow.IDSTATUS = 'P';
                        parentWidget.currentRow.VRNOTAFISC = callback.dataset.fecharNota.CABECALHO.VRNOTAFISC;
                        parentWidget.reload();
                        ScreenService.successNotification("Nota fechada com sucesso!");
                        if(popup) ScreenService.closePopup();
                    
                    }
                }
                else {
                    ScreenService.showMessage("TIMEOUT <br> Ocorreu algum erro interno no servidor. Por favor realize a operação novamente.");
                }
            }, 
            (error) => {
                if(popup) ScreenService.closePopup();
                var errosAvisos = templateManager.container.getWidget('errosAvisos');
                var bloqueia   = false;
                errosAvisos.dataSource.data = error.data.dataset.errosFechamento;
                error.data.dataset.errosFechamento.forEach((erro) => {
                    if(erro.IDERROAVISO == 'B') bloqueia = true;
                });
                errosAvisos.isVisible = true;
                errosAvisos.getAction('confirmarFechamento').isVisible = !bloqueia;
                ScreenService.openPopup(errosAvisos);
                
                ScreenService.showMessage(error.data.error);
            });
        });
    };

    this.nivelCompletoProduto = function(){
        return General.getLevelByMask('GER_CDPICTPROD','1').length;
    };
    
   /* this.getFieldFromFilterPopup = function(field, preference){
        
        var container =  templateManager.container;
        if(container) {
            var cabecalhoWidget = getCabecalhoWidget();
            if(cabecalhoWidget && cabecalhoWidget.appliedFilter)
                return cabecalhoWidget.appliedFilter.FILTER_ROW.field || 'TD';
        }
    };*/
    
    this.getFiltroCDFILIEMIT = function () {
        return CDFILIEMIT;
    };
    
    this.getFieldFromFilterPopup = function(filedName, widgetName) {
        var container =  templateManager.container;
        if(container) {
            var filterWidget;
            var filterBforeApply = templateManager.container.getActiveWidget();
            if(filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
              filterWidget = filterBforeApply;
            else {
                var f = container.getWidget(widgetName);
                if(f) {
                     filterWidget = container.getWidget(widgetName).appliedFilter;
                }
               
            }
            
            if(filterWidget) {
                var valueField;
                if(filterBforeApply.name == 'zhFilterPreferencesSelectConditions')
                    valueField = filterWidget.currentRow[filedName];
                else
                    valueField = filterWidget.FILTER_ROW[filedName];
                    
                return valueField || 'TD';
            }
            else return null;
        }
        else return null;
    };

    this.criaDataSourceFilterAfterApply = function(args) {
        var cabecalhoWidget = args.owner;
        var dataSourceFilter = cabecalhoWidget.dataSourceFilter;
        var currentRowPopup = cabecalhoWidget.appliedFilter.FILTER_ROW;
        var camposData = ['P_DTENTRSAIDINI', 'P_DTENTRSAIDFIM', 'P_DTEMISSAOINI', 'P_DTEMISSAOFIM'];
        var datasRemover = dataSourceFilter.filter(function(field){
            return camposData.indexOf(field.name) >= 0;
        });
        if(datasRemover && datasRemover.length >= 0){
            datasRemover.forEach(function(data){
                dataSourceFilter.splice(dataSourceFilter.indexOf(data), 1);
            });
        }
        var datasFiltro = dataSourceFilter.filter(function(value) {
            return value.name === "DTENTRSAID" || value.name === 'DTEMISSAO';
        });
        if(datasFiltro.length === 1){
            var dataEmissao = {
                "name": "DTEMISSAO",
                "value": {
                    0: "TD", 1: "TD"
                }
            };
            datasFiltro.push(dataEmissao);
        }
        var filterDefault = {
            'operator': '='
        };
        datasFiltro.forEach(function(data) {
            filterDefault.name = 'P_' + data.name + 'INI';
            filterDefault.value = (data.value[0] != 'TD') ? data.value[0] : '';
            dataSourceFilter.push(Util.clone(filterDefault));
            filterDefault.name = 'P_' + data.name + 'FIM';
            filterDefault.value = (data.value[1] != 'TD') ? data.value[1] : '';
            dataSourceFilter.push(Util.clone(filterDefault));
            if(data.name == 'DTEMISSAO') {
                if(data.value[0] == 'TD') {
                    filterDefault.name = 'P_TDTEMISSAO';
                    filterDefault.value = 'TD';
                    dataSourceFilter.push(Util.clone(filterDefault));
                }
                else {
                    filterDefault.name = 'P_TDTEMISSAO';
                    filterDefault.value = '';
                    dataSourceFilter.push(Util.clone(filterDefault));
                }
            }
            if(dataSourceFilter.indexOf(data) > 0)
                dataSourceFilter.splice(dataSourceFilter.indexOf(data), 1);
        });
        
        cabecalhoWidget.dataSourceFilter = cabecalhoWidget.dataSourceFilter.filter(function(field){return field.name[1] == '_';});
        let filterCDTIPOOPER = this.getFieldFromFilterPopup('CDTIPOOPER');
        if(filterCDTIPOOPER.length && filterCDTIPOOPER != 'TD')
            cabecalhoWidget.dataSourceFilter.push({operator: "IN", name: "CDTIPOOPER", value: "@Dfs11000_LancamentoSaida_Controller.getFieldFromFilterPopup('CDTIPOOPER')@"});
        
        cabecalhoWidget.reload();
    };
    
     //----------------------------------- DFS11300 Replicação de Documentos ---------------------------------------------------//
    
    this.openReplicacaoExclusao = function(args) {
        var widgetPopup = templateManager.container.getWidget('EXCLUSAONOTAREPLICADA');
        widgetPopup.cabecalhoArgs = args;
        widgetPopup.dataSourceFilter[0].value = args.row.CDFILIAL.concat(args.row.NRLANCTONF);
        widgetPopup.isVisible = true;
        widgetPopup.activate();
        widgetPopup.edit();
        ScreenService.openPopup(widgetPopup);
        widgetPopup.reload();
    };
    
    this.closeExclusao = function(widgetPopup) {
        var widget = templateManager.container.getWidget('cabecalho');
        ScreenService.closePopup(widgetPopup);
        widget.list();
        widget.activate();
        widget.reload();
    };
    
    /**
     * Valida a widget e abre a widget
     * de replicação.
     * 
     * @param {object} widget widget de 
     * uma nota fiscal.
    */
    this.openReplicacao = function(parentWidget) {
        if(parentWidget.currentRow.CDFILIRECE && parentWidget.currentRow.CDFILIEMIT) {
            //var length = parentWidget.widgets.length;
            var widget = templateManager.container.getWidget('REPLICACAODOCUMENTOS');
            ScreenService.closePopup();
            //var widget = parentWidget.widgets[length-2];
            var widgetFilha = widget.widgets[0];
            
            changeWidgetAcessibility([...parentWidget.widgets, widget], false);
            
            widget.activate();
            widget.showAsTab = true;
            parentWidget.openTab('REPLICACAODOCUMENTOS');
            
            
            widget.fields[1].reload();
            widget.reload();
            widget.edit();
            
            
            widgetFilha.edit();
            widgetFilha.actions[0].isVisible = true;
            widgetFilha.actions[1].isVisible = true;
            widgetFilha.actions[4].isVisible = false;
            widgetFilha.actions[5].isVisible = false;
            widgetFilha.reload();
        }
        else {
            ScreenService.showMessage("Replicação indisponivel para esta nota.");
        }
    };
    
    /**
     * Altera a acessibildiade da widget.
     * 
     * @param {array} widgets widgets
     * do cabecalho.
    */
	function changeWidgetAcessibility(widgets, enabled) {
		widgets.forEach(function (widget) {
			if(widget.name !== 'REPLICACAODOCUMENTOS') widget.enabled = enabled;
			else widget.enabled = !enabled;
		});
        widgets[0].getParent().enabled = enabled;
		templateManager.updateTemplate();
	}
    
    this.produtosOnEnter = function(widget, tabName, args, preference) {
        // close replicacao
        if(widget.showAsTab == true) {
            widget.showAsTab = false;
            widget.reload();
            widget.currentRow = {};
            widget.widgets[0].currentRow = {};
            widget.widgets[0].reload();
            widget.getParent().activate();
            widget.getParent().reload().then(() => {
                this.setDtsItensNotaOrigemOnEnter(args, preference);
            });
            changeWidgetAcessibility([...widget.getParent().widgets, widget], true);
            if(widget.getParent().openTab) widget.getParent().openTab(tabName);
        }
        else {
            this.setDtsItensNotaOrigemOnEnter(args, preference);
        }
    };
    
    /**
     * Cancela uma replicação.
     * 
     * @param {object} widget widget
     * de replicação.
    */
    this.closeReplicacao = function(widget, tabName) {
        if(widget.showAsTab == true) {
            widget.showAsTab = false;
            widget.reload();
            widget.currentRow = {};
            widget.widgets[0].currentRow = {};
            widget.widgets[0].reload();
            widget.getParent().activate();
            widget.getParent().reload();
            changeWidgetAcessibility([...widget.getParent().widgets, widget], true);
            if(widget.getParent().openTab) widget.getParent().openTab(tabName);
        } 
    };
    
    /**
     * Replica o documento.
     * 
     * @param {object} widget popup da replicação de 
     * documentos.
    */
    this.replicardocumento = function(widget) {
        var notafiscal = widget.getParent().getParent().currentRow;
        var erro = false;
        widget.dataSource.data.forEach(function(data) {
            if((data.CDFILIORIGRD !== notafiscal.CDFILIEMIT || data.CDFILIDESTRD !== notafiscal.CDFILIRECE) && data.IDENTRSAIDOP === 'E') erro = true;
        });
        if(erro) ScreenService.showMessage("Para toda entrada a ser gerada deve ser informada uma saída.");
        else {
            var dataset = [
                notafiscal,
                widget.getParent().currentRow,
                widget.dataSource.data
            ];
            Dfs11000_LancamentoSaida_Service.replicarDocumento(dataset).then(function(callback) {
                if(callback.dataset.replicacaoManual.ERROS_REPLICACAO){
                    
                    ErrosReplicacaoDocumentos_Utilities.errosReplicacao(widget, callback.dataset.replicacaoManual.ERROS_REPLICACAO);
                    ScreenService.showMessage("Ocorreram erros ao tentar realizar a replicação da nota fiscal.");
                }
                else {
                    ScreenService.showMessage("Replicação de documentos realizada com sucesso.");
                    this.closeReplicacao(widget.getParent(), 'cabecalho');
                }
            }.bind(this));
        }
    };
    
    /**
     * Carrega a widget de documentos e
     * altera o funcionamento para localStorage.
     * 
     * @param {object} widget widget de 
     * documentos gerados.
    */
    this.reloadDocumentos = function(widgetPai) {
        var widget = widgetPai.widgets[0];
        widget.dataSource.rest = true;
        widget.dataSource.localStorage = false;
        widget.reload().then(function(success) {
            localStorageEngine.setDataSource(widget.dataSource.name, widget.dataSource.data);
            widget.dataSource.rest = false;
            widget.dataSource.localStorage = true;
        });
    };
    
    /**
     * Abre a edição de documento.
     * E altera o readOnly/field dos campos.
     * 
     * @param {object} widget widget de 
     * documentos gerados.
    */
    this.editDocReplic = function(widget) {
        widget.actions[0].isVisible = false;
        widget.actions[1].isVisible = false;
        widget.actions[4].isVisible = true;
        widget.actions[5].isVisible = true;
        General.edit(widget);
        var operacao = widget.getField('NMTIPOOPER');
        this.readOnlyAlmoxDocumento(widget);
        
        if(widget.currentRow.IDENTRSAIDOP) {
            this.changeFieldSerie(widget.getField('CDSERIE'), widget.currentRow.IDENTRSAIDOP);
            var cdfilial = (widget.currentRow.IDENTRSAIDOP == 'S') ? 'CDFILIORIGRD' : 'CDFILIDESTRD';
            var almoxarifado = widget.getField('DSALMOXARIFE');
            var localizacao  = widget.getField('DSLOCALESTOQ');
            widget.getField('CDSERIE').readOnly = false;
            operacao.readOnly = false;
            almoxarifado.dataSourceFilter[0].value = "@General.getFieldValue('"+cdfilial+"','DOCUMENTOSGERADOS')@";
            almoxarifado.outData.CDALMOXARIFE = (widget.currentRow.IDENTRSAIDOP == 'S') ? ["CDALMOXARIFE", "CDALMOORIGRD"] : ["CDALMOXARIFE", "CDALMODESTRD"];
            localizacao.dataSourceFilter[0].value = "@General.getFieldValue('"+cdfilial+"','DOCUMENTOSGERADOS')@";
        }
    };
    
    /**
     * Salva a edição de um documento
     * no localStorage.
     * 
     * @param {object} widget widget de 
     * documentos gerados.
    */
    this.saveDoc = function(widget) {
        var data = widget.dataSource.data;
        data[widget.currentRow.__index] = widget.currentRow;
        localStorageEngine.setDataSource(widget.dataSource.name, widget.dataSource.data);
        widget.redraw();
        ScreenService.goBack();
        widget.edit();
        widget.actions[0].isVisible = true;
        widget.actions[1].isVisible = true;
        widget.actions[4].isVisible = false;
        widget.actions[5].isVisible = false;
    };
    
    /**
     * Cancela a edição de um documento.
     * 
     * @param {object} widget widget de 
     * documentos gerados.
    */
    this.cancelEditDocReplic = function(widget) {
        widget.currentRow = widget.backupRow;
        ScreenService.goBack();
        ScreenService.goBack();
        widget.edit();
        widget.actions[0].isVisible = true;
        widget.actions[1].isVisible = true;
        widget.actions[4].isVisible = false;
        widget.actions[5].isVisible = false;
    };
    
    /**
     * Verifica se filial de origem e destino são iguais.
     * Altera o readOnly dos campos ligados
     * a filial(DSALMOXARIFE, CDSERIE).
     * 
     * @param {object} field field de filial (destino ou origem)
     * da widget documentos gerados.
    */
    this.onChangeFilialDocGerado = function(field) {
        var widget  = field.widget;
        var cdfilial = (field.name == 'NMFILIORIG') ? 'CDFILIORIGRD' : 'CDFILIDESTRD';
        var cdfilial2 = (field.name == 'NMFILIORIG') ? 'CDFILIDESTRD' : 'CDFILIORIGRD';
        var filialSerie = (widget.currentRow.IDENTRSAIDOP == 'S') ? 'CDFILIORIGRD' : 'CDFILIDESTRD';
        if(widget.currentRow[cdfilial] && widget.currentRow[cdfilial2]) {
            if(widget.currentRow[cdfilial] === widget.currentRow[cdfilial2]) {
                widget.currentRow[cdfilial] = '';
                widget.currentRow[field.name] = '';
                ScreenService.showMessage('Filial de destino e origem não podem ser iguais');
            }
            else {
                if(widget.currentRow.IDENTRSAIDOP === 'S') this.setFilterSerieSaida(widget.fields[5], widget.currentRow[cdfilial]);
            }
        }
        else if(widget.currentRow.IDENTRSAIDOP === 'S' && cdfilial === 'CDFILIORIGRD' && widget.currentRow[cdfilial]) {
            this.setFilterSerieSaida(widget.fields[3], widget.currentRow[cdfilial]);
        }
        if(widget.currentRow.IDENTRSAIDOP && widget.currentRow[filialSerie]) widget.getField('CDSERIE').readOnly = false;
        else widget.getField('CDSERIE').readOnly = true;
        this.readOnlyAlmoxDocumento(widget);
    };
    
    /**
     * Altera o readOnly e filtro dos campos ligados
     * ao tipo de operação(DSALMOXARIFE, DSLOCALESTOQ, NMTIPOOPER, CDSERIE).
     * 
     * @param {object} field field de IDENTRSAIDOP (destino ou origem)
     * da widget documentos gerados.
    */
    this.onChangeIdEntrSaidaOp = function(field) {
        var widget = field.widget;
        var cdfilial = (field.value() == 'S') ? 'CDFILIORIGRD' : 'CDFILIDESTRD';
        var operacao = widget.getField('NMTIPOOPER');
        var almoxarifado = widget.getField('DSALMOXARIFE');
        var localizacao  = widget.getField('DSLOCALESTOQ');
        if(!field.value()) {
            operacao.readOnly = true;
            almoxarifado.readOnly = true;
            localizacao.readOnly = true;
        }
        else {
            this.changeFieldSerie(widget.getField('CDSERIE'), field.value());
            if(widget.currentRow[cdfilial]) {
                widget.fields[3].readOnly = false;
                widget.currentRow.CDSERIE = '';
                if(field.value() === 'S') this.setFilterSerieSaida(widget.fields[3], widget.currentRow[cdfilial]);
                if(widget.currentRow.IDENTRSAIDOP && widget.currentRow[cdfilial]) widget.getField('CDSERIE').readOnly = false;
                else widget.getField('CDSERIE').readOnly = true;
                almoxarifado.dataSourceFilter[0].value = "@General.getFieldValue('"+cdfilial+"','DOCUMENTOSGERADOS')@";
                almoxarifado.outData.CDALMOXARIFE = (field.value() == 'S') ? ["CDALMOXARIFE", "CDALMOORIGRD"] : ["CDALMOXARIFE", "CDALMODESTRD"];
                localizacao.dataSourceFilter[0].value = "@General.getFieldValue('"+cdfilial+"','DOCUMENTOSGERADOS')@";
            }
            this.readOnlyAlmoxDocumento(widget);
            operacao.readOnly = false;
        }
        operacao.reload();
        almoxarifado.setValue('');
        widget.currentRow.CDALMOXARIFE = '';
        operacao.setValue('');
        widget.currentRow.CDTIPOOPER   = '';
        localizacao.setValue('');
        widget.currentRow.CDLOCALESTOQ = '';
    };
    
    /**
     * Altera o readOnly e do campo de almoxarifado('DSALMOXARIFE')
     * de acordo com a filial e o tipo de operação('E' ou 'S').
     * 
     * @param {object} widget  widget documentos gerados.
    */
    
    this.readOnlyAlmoxDocumento = function(widget) {
        var almoxarifado = widget.getField('DSALMOXARIFE');
        if(widget.currentRow.IDENTRSAIDOP) {
            var cdfilial = (widget.currentRow.IDENTRSAIDOP == 'S') ? 'CDFILIORIGRD' : 'CDFILIDESTRD';
            almoxarifado.dataSourceFilter[0].value = "@General.getFieldValue('"+cdfilial+"','DOCUMENTOSGERADOS')@";
            if(widget.currentRow[cdfilial]) {
                var filter = [
                    {
                        "name":"CDFILIAL",
                        "operator":"=",
                        "value": widget.currentRow[cdfilial]
                    }
                ];
                General.callRestEngine('df#/crud/paramfilial', 'FilterData', filter).then(function(success){
                    if(success.dataset.paramfilial[0].IDUTILALMOX === 'S') {
                        almoxarifado.readonly = false;
                        almoxarifado.reload();
                        this.readOnlyLocalDocumento(widget);
                    } 
                }.bind(this));
            }
            else almoxarifado.readOnly = true;
        }  
        else almoxarifado.readOnly = true;
    };
    
    /**
     * Altera o readOnly e do campo de localização('DSLOCALESTOQ') 
     * de acordo com a filial e o tipo de operação('E' ou 'S').
     * 
     * @param {object} widget  widget documentos gerados.
    */
    this.readOnlyLocalDocumento = function(widget) {
        var local = widget.getField('DSLOCALESTOQ');
        if(widget.currentRow.IDENTRSAIDOP) {
            var cdfilial = (widget.currentRow.IDENTRSAIDOP == 'S') ? 'CDFILIORIGRD' : 'CDFILIDESTRD';
            if(widget.currentRow[cdfilial] && widget.currentRow.CDALMOXARIFE) {
                local.dataSourceFilter[0].value = "@General.getFieldValue('"+cdfilial+"','DOCUMENTOSGERADOS')@";
                var filter = [
                    {
                        "name":"CDFILIAL",
                        "operator":"=",
                        "value": widget.currentRow[cdfilial]
                    }
                ];
                General.callRestEngine('df#/crud/paramfilial', 'FilterData', filter).then(function(success){
                    if(success.dataset.paramfilial[0].IDUTILLCESTQ === 'S') {
                        local.reload();
                        local.readonly = false;
                    } 
                });
            }
            else local.readOnly = true;
        }  
        else local.readOnly = true;
    };
    
    /**
     * Altera o filtro do field de serie com os valores 
     * referentes a filial. - Somente para IDENTRSAIDOP = 'S' -
     * 
     * @param {object} fieldSerie field 'CDSERIE' da
     * widget documentos gerados.
     * @param {string} filial código da filial
    */
    this.setFilterSerieSaida = function(fieldSerie, filial) {
        var filter = [
            {
                "name":"CDFILIAL",
                "operator":"=",
                "value": filial
            }
        ];
        General.callRestEngine('df#/crud/filial', 'FilterData', filter).then(function(success){
            var rowFilial = success.dataset.filial;
            fieldSerie.dataSourceFilter[0].value =  rowFilial[0].CDEMPRESA;
            fieldSerie.dataSourceFilter[1].value =  rowFilial[0].CDINSCESTA;
            fieldSerie.dataSourceFilter[2].value =  rowFilial[0].CDINSCMUNI;
            fieldSerie.reload();
        });
    };
    
    /**
     * Altera o filed de 'CDSERIE' de acordo com 
     * IDENTRSAIDOP.
     * 
     * @param {object} fieldSerie field 'CDSERIE' da
     * widget documentos gerados.
     * @param {string} IDENTRSAIDOP 'E' para entrada
     * 'S' para saída
    */
    this.changeFieldSerie = function(field, IDENTRSAIDOP) {
        if(IDENTRSAIDOP === 'E') {
            field.valueField = "CDSERIEENTR";
            field.descriptionField = "CDSERIEENTR";
            field.outData = {"CDSERIEENTR": "CDSERIE"};
            field.dataSource.name = "df#/crud/serieentr";
            field.order = "CDSERIEENTR";
            field.dataSourceFilter = [];
            field.fields[0].isVisible = true;
            field.fields[1].isVisible = true;
            field.fields[2].isVisible = false;
            field.fields[3].isVisible = false;
            if(field.selectWidget)  {
                field.selectWidget.fields[0].isVisible = true;
                field.selectWidget.fields[1].isVisible = true;
                field.selectWidget.fields[2].isVisible = false;
                field.selectWidget.fields[3].isVisible = false;
                field.selectWidget.redraw();
            }
        }
        else if(IDENTRSAIDOP === 'S') {
            field.valueField = "CDSERIE";
            field.descriptionField = "CDSERIE";
            field.outData = {"CDSERIE": "CDSERIE"};
            field.dataSource.name = "df#/crud/serienf";
            field.order = "CDSERIE";
            field.fields[0].isVisible = false;
            field.fields[1].isVisible = false;
            field.fields[2].isVisible = true;
            field.fields[3].isVisible = true;
            if(field.selectWidget)  {
                field.selectWidget.outData = {"CDSERIE": "CDSERIE"};
                field.selectWidget.fields[0].isVisible = false;
                field.selectWidget.fields[1].isVisible = false;
                field.selectWidget.fields[2].isVisible = true;
                field.selectWidget.fields[3].isVisible = true;
                field.selectWidget.redraw();
            }
            field.dataSourceFilter = [
                {
                    "name": "CDEMPRESA",
                    "operator": "=",
                    "value": ""
                },
                {
                    "name": "CDINSCESTA",
                    "operator": "=",
                    "value": ""
                },
                {
                    "name": "CDINSCMUNI",
                    "operator": "=",
                    "value": ""
                }
            ];
        }
        field.reload();
    };
    
    //Função para consultar posição de estoque do produto escolhido para setar validação de quantidade maximo para o lançamento
    //OBS: verificar possibilidade de refatorar a busca da datadeprocessamento e busca-la de outro local para evitar requisição ao back.
    this.atualizaMaxQuantidade = function(widget) {
        var mensagem;
        var filial = widget.currentRow.CDFILIMOVI;
        var result = 0; 
        if(widget.currentRow.QTESTOQDIA === undefined){ // QTESTOQDIA será undefined caso unidade não controle almoxarifado ou local de estoque.

            widget.currentRow.IDQUANTID = 'N';
            if(!widget.currentRow.NRLOTEESTQ) widget.currentRow.NRLOTEESTQ = ' ';
                
            if(!widget.currentRow.NRSUBLOTE) widget.currentRow.NRSUBLOTE = ' ';
                
            if(!widget.currentRow.DTLANCMOVI) widget.currentRow.DTLANCMOVI = widget.getParent().currentRow.DTENTRSAID;
                
            if(!widget.currentRow.CDALMOXARIFE) widget.currentRow.CDALMOXARIFE = ' ';
                
            if(!widget.currentRow.CDLOCALESTOQ) widget.currentRow.CDLOCALESTOQ = ' ';

            
            ValidacoesEstoque_Service.verificaEstoqueProduto(widget.currentRow).then(function(success){
                if(success.dataset.lote_infCompl_semAlmox.length > 0) {
                    result = success.dataset.lote_infCompl_semAlmox[0].QTESTOQDIA; 
                }
                mensagem = "Posição Estoque: ".concat(result);
                widget.getField('QTITEMPROD').validations.max = {"value": result, "message": mensagem};
                General.callRestEngine("df#/crud/paramfilial", "FilterData", [{"name": "CDFILIAL", "operator": "=", "value": widget.currentRow.CDFILIAL}]).then((retorno) => {
                    if(widget.currentRow.IDCNTRESTOQ == 'N' || widget.getParent().currentRow.IDATUESTTPOP == 'N')
                        delete(widget.getField('QTITEMPROD').validations.max);  
                    else if(retorno.dataset.paramfilial[0].IDPERMESTNEG == 'S') 
                        delete(widget.getField('QTITEMPROD').validations.max);  
                    else if(widget.currentRow.CDSERVFILI)
                        delete(widget.getField('QTITEMPROD').validations.max);  
                });
            });    
            
        }else{
            mensagem = "Posição Estoque: ".concat(widget.currentRow.QTESTOQDIA);
            widget.getField('QTITEMPROD').validations.max = {"value": widget.currentRow.QTESTOQDIA, "message": mensagem};
            if(widget.currentRow.IDCNTRESTOQ == 'N' || widget.getParent().currentRow.IDATUESTTPOP == 'N')
                delete(widget.getField('QTITEMPROD').validations.max);
        }    
        
    };
    
    this.openPopupCopiarNF = function() {
        var wdgCopia = templateManager.container.getWidget('WidgetCopiarNF');
        var currentRowCabecalho = templateManager.container.getWidget('cabecalho').currentRow;
        if(currentRowCabecalho.IDSTATUS != 'D'){
            wdgCopia.currentRow = Util.clone(currentRowCabecalho);
            wdgCopia.getField("NMRAZSOCCLIE").dataSourceFilter[0].value = wdgCopia.currentRow.CDFILIEMIT;
            wdgCopia.currentRow.DTLANCAMENNF = moment().format('DD/MM/YYYY');
            wdgCopia.currentRow.LOTEORIG  = 'S';
            
            ScreenService.openPopup(wdgCopia);
            alteraVisibilidadeCampoInscricao(wdgCopia);
        }else{
            ScreenService.showMessage('Não é possível copiar notas em digitação');
        }
    };
    
    this.closePopupCopiaNF = function() {
        var wdgCopia = templateManager.container.getWidget('WidgetCopiarNF');
        ScreenService.closePopup(wdgCopia);
        wdgCopia.isVisible = false;
    };
    
    this.copiarNF = function(widget){
        if (widget.isValid()){
            let row = widget.currentRow;
            Dfs11000_LancamentoSaida_Service.copiarNF(row).then(function(success){
                this.closePopupCopiaNF();
                ScreenService.closePopup();
                ScreenService.closeSwipe();
                templateManager.container.getWidget('cabecalho').reload();
                ScreenService.showMessage(success.dataset.copiarNF.success);
                ScreenService.closePopup();
            }.bind(this)
            ).catch(function(error) {
                 ScreenService.closePopup();
                    var errosCopiar = templateManager.container.getWidget('errosCopiar');
                    if(error.data.dataset){
                        errosCopiar.dataSource.data = error.data.dataset.errosCopiarNF;
                        errosCopiar.isVisible = true;
                        ScreenService.openPopup(errosCopiar);
                    }
                    
                    ScreenService.showMessage(error.data.error);
            });
        }
    };
    
    this.popUpOperacaoOnChange = function(widget){
        alteraVisibilidadeCampoInscricao(widget);
        limpaCamposOutDataSelectsTpOperac(widget);
    };
    
    this.beginDataUpdate = function(widCabecalho) {
        if(!widCabecalho.dataSource.data.length) ScreenService.showMessage("É necessário filtrar dados para atualizar.");
        else {
            let widDataUpdate = getDataUpdateWidget();
            let tabDataUpdate = templateManager.container.getWidget('tabDataUpdate');
            let newDtSaida = tabDataUpdate.getField('NEWDTENTRSAID');
            
            this.openPopupDataUpdate(tabDataUpdate);
            if(newDtSaida.value()) newDtSaida.setValue();
            
            widDataUpdate.dataSourceFilter = widCabecalho.dataSourceFilter;
            widDataUpdate.reload();
        }
    };
    
    this.openPopupDataUpdate = function(widTabDataUpdate) {
        widTabDataUpdate.isVisible = true;
        ScreenService.openPopup(widTabDataUpdate);
        widTabDataUpdate.activate();
    };
    
    this.saveDataUpdate = function(tabDataUpdate, widDataUpdate) {
        if(tabDataUpdate.isValid()) {
            if(!widDataUpdate.hasCheckedRows()) ScreenService.showMessage("Selecione uma nota para atualizar.");
            else {
                let self = this;
                ScreenService.confirmMessage('Confirma a atualização e o fechamento da(s) nota(s) ?', 'question', function (success) {
                    let rowsUpdate = widDataUpdate.getCheckedRows();
                    let NEWDTENTRSAID = tabDataUpdate.getField('NEWDTENTRSAID').value();
                    Dfs11000_LancamentoSaida_Service.saveDataUpdate(rowsUpdate, NEWDTENTRSAID).then (function (success) {
                        widDataUpdate.reload().then(() => {
                            if(widDataUpdate.dataSource.data.length) widDataUpdate.unSelectAll();
                            else self.closePopupDataUpdate(tabDataUpdate);
                        });
                        ScreenService.showMessage(success.messages[0].message);
                    }, requestError);
                });
            }
        }
    };
    
    this.closePopupDataUpdate = function(widTabDataUpdate) {
        let widDataUpdate = getDataUpdateWidget();
        
        widDataUpdate.unSelectAll();
        widDataUpdate.dataSource.data = [];
        
        widTabDataUpdate.isVisible = false;
        ScreenService.closePopup(widTabDataUpdate);
        widTabDataUpdate.getParent().activate();
        widTabDataUpdate.getParent().reload();
    };
    
    let getDataUpdateWidget = function() {
        return templateManager.container.getWidget('wdg_DataUpdate');
    };
    
    this.getFieldSerieFromFilterPopup = function(fieldSerie) {
        fieldSerie.dataSourceFilter.forEach(data => {
            if(data.name == "CDEMPRESA") data.value = this.getFieldFromFilterPopup('CDEMPRESA');
            if(data.name == "CDINSCESTA") data.value = this.getFieldFromFilterPopup('IEREM');
            if(data.name == "CDINSCMUNI") data.value = this.getFieldFromFilterPopup('CDINSCMUNI');
        });
    };
    
    this.nmPaisNotaOnChange = function(widget) {
        widget.getField('SGESTADONOTA').readOnly = widget.currentRow.CDPAISNOTA ? false : true;
        widget.getField('NMMUNICIPIONOTA').readOnly = true;
        widget.currentRow.CDMUNICIPIO = null;
        widget.currentRow.CDMUNICIPIONOTA = null;
        widget.currentRow.NMMUNICIPIONOTA = null;
        widget.currentRow.SGESTADO = null;
        widget.currentRow.SGESTADONOTA = null;
        widget.currentRow.NMESTADONOTA = null;
        if (widget.currentRow.CDPAISNOTA) {
    		widget.getField('SGESTADONOTA').dataSourceFilter.forEach(data => {
    		    if(data.name == "CDPAIS") data.value = widget.currentRow.CDPAISNOTA;
    		});
    		widget.getField('NMMUNICIPIONOTA').dataSourceFilter.forEach(data => {
    		    if(data.name == "CDPAIS") data.value = widget.currentRow.CDPAISNOTA;
    		});
        }
    };
    
    this.sgEstadoNotaOnChange = function(widget) {
        widget.getField('NMMUNICIPIONOTA').readOnly = widget.currentRow.SGESTADONOTA ? false : true;
        widget.currentRow.CDMUNICIPIO = null;
        widget.currentRow.CDMUNICIPIONOTA = null;
        widget.currentRow.NMMUNICIPIONOTA = null;
		widget.currentRow.SGESTADO = widget.currentRow.SGESTADONOTA;
		if (widget.currentRow.SGESTADONOTA) {
    		widget.getField('NMMUNICIPIONOTA').dataSourceFilter.forEach(data => {
    		    if(data.name == "SGESTADO") data.value = widget.currentRow.SGESTADONOTA;
    		});
		}
    };
    
    this.nmMunicipioNotaOnChange = function(widget) {
        widget.currentRow.CDMUNICIPIO = widget.currentRow.CDMUNICIPIONOTA;
   };
    
    this.controlVisibilityLocalPrestServ = function(widget) {
        let fieldSGESTADONOTA = widget.getField('SGESTADONOTA');
        let fieldNMMUNICIPIONOTA = widget.getField('NMMUNICIPIONOTA');
        let fieldNMPAISNOTA = widget.getField('NMPAISNOTA');
        let fieldIDNATUOPER = widget.getField('IDNATUOPER');
        let utilizaNFSe = widget.currentRow.IDUTILNFSE === 'S' ? true : false;
        
        if(widget.editing) { //True = Add e edit nota.
            if(utilizaNFSe) {
                if(widget.currentRow.__is_new) {
                    widget.currentRow.IDNATUOPER = null;
                    widget.currentRow.CDPAISNOTA = null;
                    widget.currentRow.NMPAISNOTA = null;
                    widget.currentRow.CDMUNICIPIONOTA = null;
                    widget.currentRow.NMMUNICIPIONOTA = null;
                    widget.currentRow.SGESTADONOTA = null;
                    widget.currentRow.NMESTADONOTA = null;
                } else {
                    if (widget.currentRow.CDPAISNOTA) {
                        widget.getField('SGESTADONOTA').dataSourceFilter.forEach(data => {
                		    if(data.name == "CDPAIS") data.value = widget.currentRow.CDPAISNOTA;
                		});
                		widget.getField('NMMUNICIPIONOTA').dataSourceFilter.forEach(data => {
                		    if(data.name == "CDPAIS") data.value = widget.currentRow.CDPAISNOTA;
                		});
                    }
                    if (widget.currentRow.SGESTADONOTA) {
                        widget.getField('NMMUNICIPIONOTA').dataSourceFilter.forEach(data => {
                		    if(data.name == "SGESTADO") data.value = widget.currentRow.SGESTADONOTA;
                		});
                    }
                }
                widget.fieldGroups.forEach(group => {
                    if(group.name === 'prestacaoServico') {
                        group.isVisible = true;
                        group.opened = true;
                    }
                });
                widget.currentRow.SGESTADO = widget.currentRow.SGESTADONOTA;
                widget.currentRow.CDMUNICIPIO = widget.currentRow.CDMUNICIPIONOTA;
                
                fieldIDNATUOPER.isVisible = true;
                fieldIDNATUOPER.readOnly = false;
                fieldIDNATUOPER.validations.required = true;
                
                fieldNMPAISNOTA.isVisible = true;
                fieldNMPAISNOTA.readOnly = false;
                fieldNMPAISNOTA.validations.required = true;
                
                fieldSGESTADONOTA.isVisible = true;
                fieldSGESTADONOTA.readOnly = widget.currentRow.CDPAISNOTA ? false : true;
                fieldSGESTADONOTA.validations.required = true;
                
                fieldNMMUNICIPIONOTA.isVisible = true;
                fieldNMMUNICIPIONOTA.readOnly = widget.currentRow.SGESTADONOTA ? false : true;
                fieldNMMUNICIPIONOTA.validations.required = true;
            } else {
                widget.fieldGroups.forEach(group => {
                    if(group.name === 'prestacaoServico') {
                        group.isVisible = false;
                        group.opened = false;
                    }
                });
                fieldIDNATUOPER.isVisible = false;
                fieldIDNATUOPER.readOnly = true;
                fieldIDNATUOPER.validations.required = false;
                
                fieldNMPAISNOTA.isVisible = false;
                fieldNMPAISNOTA.readOnly = true;
                fieldNMPAISNOTA.validations.required = false;
                
                fieldSGESTADONOTA.isVisible = false;
                fieldSGESTADONOTA.readOnly = true;
                fieldSGESTADONOTA.validations.required = false;
                
                fieldNMMUNICIPIONOTA.isVisible = false;
                fieldNMMUNICIPIONOTA.readOnly = true;
                fieldNMMUNICIPIONOTA.validations.required = false;
            }
        } else { //False = Visualizar nota.
            if(utilizaNFSe) {
                widget.fieldGroups.forEach(group => {
                    if(group.name === 'prestacaoServico') {
                        group.isVisible = true;
                    }
                });
                fieldIDNATUOPER.isVisible = true;
                fieldNMPAISNOTA.isVisible = true;
                fieldSGESTADONOTA.isVisible = true;
                fieldNMMUNICIPIONOTA.isVisible = true;
            } else {
                widget.fieldGroups.forEach(group => {
                    if(group.name === 'prestacaoServico') {
                        group.isVisible = false;
                    }
                });
                fieldIDNATUOPER.isVisible = false;
                fieldNMPAISNOTA.isVisible = false;
                fieldSGESTADONOTA.isVisible = false;
                fieldNMMUNICIPIONOTA.isVisible = false;
            }
        }
   };
};

Configuration(function(ContextRegister) {
    ContextRegister.register("Dfs11000_LancamentoSaida_Controller", dfs11000_LancamentoSaida_Controller);
});