var Dfs85000_ManifestoDocumentoEletronico_Service = function(General, ZHPromise, localStorageEngine){
    
   this.buildFilter = function(fieldsName, currentRow, insstr = false) {
        var deferred = ZHPromise.defer();
        let filter = [];
        fieldsName.forEach((fieldName) => {
            var value;
            if(fieldName != "NRMDFEINI" && fieldName != "NRMDFEFIN") {
                value = 'T';
            }
            else {
                value = '';
            }
            
            if (currentRow[fieldName]) {
                if (Array.isArray(currentRow[fieldName])) {
                    if (currentRow[fieldName].length) {
                        value = montaInStr(currentRow[fieldName]);
                    }
                }
                else {
                    value = currentRow[fieldName];
                }
            }
            
            filter.push({
                "name": "P_".concat(fieldName),
                "operator": "=",
                "value": value
            }); 
        });
        deferred.resolve(filter);
        return deferred.promise;
    };
    
    this.setDefaultMdfe = function(defaultMdfe) {
        return localStorageEngine.setDataSource("df#/defaultMdfe", defaultMdfe);
    };
    
    this.getDefaultMdfe = function() {
        return localStorageEngine.getDataSource("df#/defaultMdfe");
    };
    
    var montaInStr = function(row) {
        var strReturn = '_';
        row.forEach((value) => {
            strReturn += value + '_';
        });
        return strReturn;
    };
    
    this.saveNotasRelacionadas = function (widget) {
        var rows = widget.getCheckedRows();
        var widgetManifesto = widget.container.getWidget('manifesto_eletronico');
        
        var cdviatura = widgetManifesto.currentRow.CDVIATURA;
        var nrlanctomdfe = widgetManifesto.currentRow.NRLANCTOMDFE;
        
        rows.forEach( row => {
            row.CDVIATURA = cdviatura;
            row.NRLANCTOMDFE = nrlanctomdfe;
            row.__is_new = true;
        });
        
        return General.callRestEngine("df#/notasRelacionadasMdfe/save", "DataSet", rows);
    };
    

};

Configuration(function (ContextRegister){
    ContextRegister.register('Dfs85000_ManifestoDocumentoEletronico_Service', Dfs85000_ManifestoDocumentoEletronico_Service);
});
