const ZeedhiAPIConstructor = require('zeedhi-functional-test-api');
const z = new ZeedhiAPIConstructor(browser, protractor);
const Helper = require('teknisa-helper');
const geralPage = new Helper.geral();
const loginPage = new Helper.login();
const mensagemPage = require('../../../page-objects/parametrizacao/documentos fiscais/mensagem.po.js');
const j = require('../../../json/leitorJson.po');

describe('Tela Tipo de Mensagem', () => {
    beforeEach(() => {
        loginPage.login(j.getValor('login'), j.getValor('senha'));
        geralPage.abrir(['Parametrização', 'Documentos Fiscais', 'Mensagem']);
        z.component.footer.clickRightActionByLabel('Filtrar', true);
    });

    afterEach(() => {
        geralPage.sair();
    });

    it('Acessar a tela Mensagem', () => {
        expect(z.component.header.getTitle()).toBe('Mensagem');
    });

    it('Inserir Registro', () => {
        mensagemPage.adicionarMensagem(j.getValor('codigomsg'), j.getValor('descmensagem'), j.getValor('ativomsg'));
        geralPage.filterIt(j.getValor('descmensagem'));
        expect(geralPage.gridHasText('78986357041572372561434', j.getValor('descmensagem'), 1)).toBe(j.getValor('descmensagem'));
    });

    it('Inserir Registro', () => {
        mensagemPage.adicionarMensagem(j.getValor('codigomsg1'), j.getValor('descmensagem1'), j.getValor('ativomsg1'));
        geralPage.filterIt(j.getValor('descmensagem1'));
        expect(geralPage.gridHasText('78986357041572372561434', j.getValor('descmensagem1'), 1)).toBe(j.getValor('descmensagem1'));
    });

    it('Inserir Registro', () => {
        mensagemPage.adicionarMensagem(j.getValor('codigomsg2'), j.getValor('descmensagem2'), j.getValor('ativomsg2'));
        geralPage.filterIt(j.getValor('descmensagem2'));
        expect(geralPage.gridHasText('78986357041572372561434', j.getValor('descmensagem2'), 1)).toBe(j.getValor('descmensagem2'));
    });

    it('Editar Registro', () => {
        geralPage.filterIt(j.getValor('descmensagem1'));
        geralPage.clickGrid('DSMENSAGEM', j.getValor('descmensagem1'), '78986357041572372561434', false);
        geralPage.clickEditar();
        mensagemPage.editarMensagem(j.getValor('descmensagem3'), j.getValor('ativomsg'));
        geralPage.clickSalvar();
        expect(geralPage.getTextoPorId('DSMENSAGEM')).toBe(j.getValor('descmensagem3'));
    });

    it('Excluir Registro', () => {
        geralPage.filterIt(j.getValor('descmensagem'));
        geralPage.clickGrid(('DSMENSAGEM'), j.getValor('descmensagem'), '78986357041572372561434');
        mensagemPage.excluirMensagem();
        expect(geralPage.gridHasText('78986357041572372561434', j.getValor('descmensagem'), 1, false)).toBeUndefined();
    });
});
